<?php
namespace Controller;

use Service\DeleteCascadeService;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Style extends Crud {
	
	protected $dataSourceName = 'style';

    protected $styleService;

	public function __construct(Manager $mongoManager, DeleteCascadeService $deleteCascadeService, $styleService) {
		parent::__construct($mongoManager, $deleteCascadeService);
        $this->styleService = $styleService;
	}

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $style = array();
        $baseStyle = $this->styleService->getStyleFromBase();
        $orgStyle = $this->styleService->getStyleFromOrg();
        $style = array_merge($baseStyle, $orgStyle);

        $response->addDataSet(new DataSet('style', $style));
    }
}