<?php

namespace Controller;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Controller\Crud as CrudDB;
use Zeedhi\Framework\DataSource\Manager;
use Util\Environment;
use Util\Utilities;


class ZmartNameOrg extends CrudDB{

    /** @var Environment $environment */
    protected  $environment;

    protected $dataSourceName = "nameOrg";

    public function __construct(Manager $dataSourceManager, Environment $environment) {
        parent::__construct($dataSourceManager);
        $this->environment = $environment;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $dataset = CrudDB::find($request, $response);
    }

    public function setNrOrgClient(DTO\Request\Filter $request, DTO\Response $response) {
        $parameters = $request->getFilterCriteria()->getConditions();
        $nrorg = Utilities::getValueInFilterDataSourceByName($parameters, 'NRORG');
        $nrorgprincipal = Utilities::getValueInFilterDataSourceByName($parameters, 'NRORGPRINCIPAL');
        $this->environment->setNrOrgClient($nrorg);
        $this->environment->setNrOrgClientPrincipal($nrorgprincipal);
    }

}
