<?php
namespace Service\Mail;

use Service\Mail\Core\SmtpMail;
use Util\Messages;
use Zend\Mime\Part as ZendMimePart;
use Zend\Mime\Message as ZendMimeMessage;

class LoginMail {
 
    private $smtpMail;
    private $baseDir = '';

    public function __construct(SmtpMail $smtpMail){
        $this->smtpMail = $smtpMail;
        $this->baseDir = __DIR__.DIRECTORY_SEPARATOR.'EmailTemplates'.DIRECTORY_SEPARATOR;
    }
    
    public function getMailChangeLoginTemplaPath() {
        $defaultFile = $this->baseDir . 'change_password_login.html';
        return $defaultFile;
    }
    
    public function getMailChangeLogin_lasses_TemplaPath() {
        $defaultFile = $this->baseDir . 'change_password_login_LASSES.html';
        return $defaultFile;
    }
                                               
    public function sendMessageChangeLoginMail($to, $name, $user, $password, $date, $sistema){
        if($sistema === 'zmart'){
            $senderName = "zmart@teknisa.com";
            $messagePrevius = $this->buildMessageMail($name, $user, $password, $date);
        } else{
            $senderName = "";
            $messagePrevius = $this->buildMessageMail_LASSES($name, $user, $password, $date);
        }
        
        $subject = "Alteração de senha";

        $message = utf8_decode($messagePrevius);
        $mimePart = new ZendMimePart($message);
        $mimePart->type = 'text/html';
        $mimeMessage = new ZendMimeMessage();
        $mimeMessage->setParts(array($mimePart));

        $message = $mimeMessage; 
        $this->sendHtml($to, $subject, $message, $senderName);
    }
    
    public function buildMessageMail($name, $user, $password, $date){
        $replacedContents = $this->fileGetContentUtf8($this->getMailChangeLoginTemplaPath());
        $replacedContents = str_replace('%name%', $name, $replacedContents);
        $replacedContents = str_replace('%user%', $user, $replacedContents);
        $replacedContents = str_replace('%password%', $password, $replacedContents);
        $replacedContents = str_replace('%data%', $date, $replacedContents);
        return $replacedContents;
    }
    
    public function buildMessageMail_LASSES($name, $user, $password, $date){
        $replacedContents = $this->fileGetContentUtf8($this->getMailChangeLogin_lasses_TemplaPath);
        $replacedContents = str_replace('%name%', $name, $replacedContents);
        $replacedContents = str_replace('%user%', $user, $replacedContents);
        $replacedContents = str_replace('%password%', $password, $replacedContents);
        $replacedContents = str_replace('%data%', $date, $replacedContents);
        return $replacedContents;
    }
    
    private function sendHtml($to, $subject, $message, $senderName){
        $this->smtpMail->setFrom($senderName);
        $this->smtpMail->setSubject($subject);
        $this->smtpMail->setBody($message);
        
        foreach($to as $address){
            $this->smtpMail->setTo($address['EMAIL']);
            $this->smtpMail->sendHtml();
        }
    }
    
    function fileGetContentUtf8($fileName) {
        $content = file_get_contents($fileName);
        return mb_convert_encoding($content, 'UTF-8',
            mb_detect_encoding($content, 'UTF-8, ISO-8859-1', true));
    }
    
}