<?php

namespace Service;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;

class StyleService {
    
    protected $dataSourceName = 'style';
    protected $orgMongoManager;
    protected $baseMongoManager;
    
    public function __construct (Manager $orgMongoManager, Manager $baseMongoManager){
        $this->orgMongoManager = $orgMongoManager;
        $this->baseMongoManager = $baseMongoManager;
    }
    
    public function getStyleFromBase(){
        $filterCriteria = new FilterCriteria($this->dataSourceName);
        $response = $this->baseMongoManager->findBy($filterCriteria)->getRows();
        
        foreach ($response as &$row) {
            $row['base'] = true;
        }
        
        return $response;
    }
    
    public function getStyleFromOrg(){
        $filterCriteria = new FilterCriteria($this->dataSourceName);
        $response = $this->orgMongoManager->findBy($filterCriteria)->getRows();
        return $response;
    }
}