/* Tabela PARAVEND: TABELA DE PARAVEND*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela PARAVEND */
/* Objetivo: Gerar um log que vai registrar as alteraes na PARAVEND,
             utilizando a tabela de Logs de Operaes do VND*/
/* Tabela PARAVEND: TABELA DE PARAVEND */ 
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela PARAVEND */ 
CREATE OR REPLACE TRIGGER LOG_VND_PARAVEND AFTER UPDATE ON PARAVEND FOR EACH ROW 
DECLARE 
    V_DSREMOTEADDR VARCHAR2(15); 
    V_DSREMOTEHOST VARCHAR2(15); 
    V_DSSERVERRDM  VARCHAR2(20); 
    V_DSSERVMETHOD VARCHAR2(30); 
    V_DSREMOTEOPER VARCHAR2(12); 
    V_DESC         VARCHAR2(4000); 
    V_ITPESQ       VARCHAR2(40); 
    V_NMOPERADOR   VARCHAR2(40); 
    V_IDTIPOOPER   VARCHAR2(1); 
BEGIN 
    /* IDTIPOOPER - '2' - Alterao */ 
    V_DESC       := ''; 
    V_ITPESQ     :=  ''; 
    V_NMOPERADOR := '';  
    V_IDTIPOOPER := ''; 
    NMUSUARIO(V_NMOPERADOR); 
    WEBTUNNING(V_DSREMOTEADDR, 
               V_DSREMOTEHOST, 
               V_DSSERVERRDM, 
               V_DSSERVMETHOD, 
               V_DSREMOTEOPER); 
    IF UPDATING THEN
        IF NVL(:NEW.CDFILIAL, 'NULL') <> NVL(:OLD.CDFILIAL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDFILIAL ' || ' ' || NVL(:NEW.CDFILIAL, '');
        END IF; 
        IF NVL(:NEW.CDPARAVEND, 'NULL') <> NVL(:OLD.CDPARAVEND, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDPARAVEND ' || ' ' || NVL(:NEW.CDPARAVEND, '');
        END IF; 
        IF NVL(:NEW.CDPRODUTO, 'NULL') <> NVL(:OLD.CDPRODUTO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDPRODUTO ' || ' ' || NVL(:NEW.CDPRODUTO, '');
        END IF; 
        IF NVL(:NEW.CDCLIENTE, 'NULL') <> NVL(:OLD.CDCLIENTE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCLIENTE ' || ' ' || NVL(:NEW.CDCLIENTE, '');
        END IF; 
        IF NVL(:NEW.NMULTIMOTXT, 'NULL') <> NVL(:OLD.NMULTIMOTXT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NMULTIMOTXT ' || ' ' || NVL(:NEW.NMULTIMOTXT, '');
        END IF; 
        IF NVL(:NEW.IDCONSUMIOBR, 'NULL') <> NVL(:OLD.IDCONSUMIOBR, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSUMIOBR ' || ' ' || NVL(:NEW.IDCONSUMIOBR, '');
        END IF; 
        IF NVL(:NEW.QTDIGCDIDCON, 99999) <> NVL(:OLD.QTDIGCDIDCON, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'QTDIGCDIDCON ' || ' ' || NVL(:NEW.QTDIGCDIDCON, '');
        END IF; 
        IF NVL(:NEW.CDDIGCDIDCON, 'NULL') <> NVL(:OLD.CDDIGCDIDCON, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDDIGCDIDCON ' || ' ' || NVL(:NEW.CDDIGCDIDCON, '');
        END IF; 
        IF NVL(:NEW.IDATUEST, 'NULL') <> NVL(:OLD.IDATUEST, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDATUEST ' || ' ' || NVL(:NEW.IDATUEST, '');
        END IF; 
        IF NVL(:NEW.CDSERVFILI, 'NULL') <> NVL(:OLD.CDSERVFILI, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDSERVFILI ' || ' ' || NVL(:NEW.CDSERVFILI, '');
        END IF; 
        IF NVL(:NEW.IDSERVPAD, 'NULL') <> NVL(:OLD.IDSERVPAD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDSERVPAD ' || ' ' || NVL(:NEW.IDSERVPAD, '');
        END IF; 
        IF NVL(:NEW.IDIMPCUPFIS, 'NULL') <> NVL(:OLD.IDIMPCUPFIS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPCUPFIS ' || ' ' || NVL(:NEW.IDIMPCUPFIS, '');
        END IF; 
        IF NVL(:NEW.CDEMPRESA, 'NULL') <> NVL(:OLD.CDEMPRESA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDEMPRESA ' || ' ' || NVL(:NEW.CDEMPRESA, '');
        END IF; 
        IF NVL(:NEW.CDINSCESTA, 'NULL') <> NVL(:OLD.CDINSCESTA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDINSCESTA ' || ' ' || NVL(:NEW.CDINSCESTA, '');
        END IF; 
        IF NVL(:NEW.CDINSCMUNI, 'NULL') <> NVL(:OLD.CDINSCMUNI, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDINSCMUNI ' || ' ' || NVL(:NEW.CDINSCMUNI, '');
        END IF; 
        IF NVL(:NEW.CDSERIE, 'NULL') <> NVL(:OLD.CDSERIE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDSERIE ' || ' ' || NVL(:NEW.CDSERIE, '');
        END IF; 
        IF NVL(:NEW.CDTABEPREC, 'NULL') <> NVL(:OLD.CDTABEPREC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTABEPREC ' || ' ' || NVL(:NEW.CDTABEPREC, '');
        END IF; 
        IF NVL(:NEW.IDFORMAPRECO, 'NULL') <> NVL(:OLD.IDFORMAPRECO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDFORMAPRECO ' || ' ' || NVL(:NEW.IDFORMAPRECO, '');
        END IF; 
        IF NVL(:NEW.IDCUSFOPRECO, 'NULL') <> NVL(:OLD.IDCUSFOPRECO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCUSFOPRECO ' || ' ' || NVL(:NEW.IDCUSFOPRECO, '');
        END IF; 
        IF NVL(:NEW.IDPRECDIFCOM, 'NULL') <> NVL(:OLD.IDPRECDIFCOM, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPRECDIFCOM ' || ' ' || NVL(:NEW.IDPRECDIFCOM, '');
        END IF; 
        IF NVL(:NEW.IDORIGVENDA, 'NULL') <> NVL(:OLD.IDORIGVENDA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDORIGVENDA ' || ' ' || NVL(:NEW.IDORIGVENDA, '');
        END IF; 
        IF NVL(:NEW.NRDIAFATVEND, 'NULL') <> NVL(:OLD.NRDIAFATVEND, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIAFATVEND ' || ' ' || NVL(:NEW.NRDIAFATVEND, '');
        END IF; 
        IF NVL(:NEW.IDPERDIGCONS, 'NULL') <> NVL(:OLD.IDPERDIGCONS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERDIGCONS ' || ' ' || NVL(:NEW.IDPERDIGCONS, '');
        END IF; 
        IF NVL(:NEW.CDLOJA, 'NULL') <> NVL(:OLD.CDLOJA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDLOJA ' || ' ' || NVL(:NEW.CDLOJA, '');
        END IF; 
        IF NVL(:NEW.NRDIASVENDA, 'NULL') <> NVL(:OLD.NRDIASVENDA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIASVENDA ' || ' ' || NVL(:NEW.NRDIASVENDA, '');
        END IF; 
        IF NVL(:NEW.IDTESESTCONS, 'NULL') <> NVL(:OLD.IDTESESTCONS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDTESESTCONS ' || ' ' || NVL(:NEW.IDTESESTCONS, '');
        END IF; 
        IF NVL(:NEW.IDCRIPTOCONS, 'NULL') <> NVL(:OLD.IDCRIPTOCONS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCRIPTOCONS ' || ' ' || NVL(:NEW.IDCRIPTOCONS, '');
        END IF; 
        IF NVL(:NEW.QTDIGICOMAND, 99999) <> NVL(:OLD.QTDIGICOMAND, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'QTDIGICOMAND ' || ' ' || NVL(:NEW.QTDIGICOMAND, '');
        END IF; 
        IF NVL(:NEW.CDTIPOCONS, 'NULL') <> NVL(:OLD.CDTIPOCONS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOCONS ' || ' ' || NVL(:NEW.CDTIPOCONS, '');
        END IF; 
        IF NVL(:NEW.CDCCUSCLIE, 'NULL') <> NVL(:OLD.CDCCUSCLIE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCCUSCLIE ' || ' ' || NVL(:NEW.CDCCUSCLIE, '');
        END IF; 
        IF NVL(:NEW.IDPERMARCDUP, 'NULL') <> NVL(:OLD.IDPERMARCDUP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERMARCDUP ' || ' ' || NVL(:NEW.IDPERMARCDUP, '');
        END IF; 
        IF NVL(:NEW.IDALTPRECO, 'NULL') <> NVL(:OLD.IDALTPRECO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDALTPRECO ' || ' ' || NVL(:NEW.IDALTPRECO, '');
        END IF; 
        IF NVL(:NEW.CDTPCONSDUP, 'NULL') <> NVL(:OLD.CDTPCONSDUP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPCONSDUP ' || ' ' || NVL(:NEW.CDTPCONSDUP, '');
        END IF; 
        IF NVL(:NEW.CDGRPRODPDV, 'NULL') <> NVL(:OLD.CDGRPRODPDV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDGRPRODPDV ' || ' ' || NVL(:NEW.CDGRPRODPDV, '');
        END IF; 
        IF NVL(:NEW.NRPOSINICONS, 99999) <> NVL(:OLD.NRPOSINICONS, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRPOSINICONS ' || ' ' || NVL(:NEW.NRPOSINICONS, '');
        END IF; 
        IF NVL(:NEW.NRPOSFINCONS, 99999) <> NVL(:OLD.NRPOSFINCONS, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRPOSFINCONS ' || ' ' || NVL(:NEW.NRPOSFINCONS, '');
        END IF; 
        IF NVL(:NEW.IDUTDLLEXSEG, 'NULL') <> NVL(:OLD.IDUTDLLEXSEG, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTDLLEXSEG ' || ' ' || NVL(:NEW.IDUTDLLEXSEG, '');
        END IF; 
        IF NVL(:NEW.CDPDVDLLSEG, 'NULL') <> NVL(:OLD.CDPDVDLLSEG, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDPDVDLLSEG ' || ' ' || NVL(:NEW.CDPDVDLLSEG, '');
        END IF; 
        IF NVL(:NEW.CDPOODLLSEG, 'NULL') <> NVL(:OLD.CDPOODLLSEG, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDPOODLLSEG ' || ' ' || NVL(:NEW.CDPOODLLSEG, '');
        END IF; 
        IF NVL(:NEW.CDCXADLLSEG, 'NULL') <> NVL(:OLD.CDCXADLLSEG, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCXADLLSEG ' || ' ' || NVL(:NEW.CDCXADLLSEG, '');
        END IF; 
        IF NVL(:NEW.QTMEDVENDDIA, 99999) <> NVL(:OLD.QTMEDVENDDIA, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'QTMEDVENDDIA ' || ' ' || NVL(:NEW.QTMEDVENDDIA, '');
        END IF; 
        IF NVL(:NEW.IDUTSUBTCONS, 'NULL') <> NVL(:OLD.IDUTSUBTCONS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTSUBTCONS ' || ' ' || NVL(:NEW.IDUTSUBTCONS, '');
        END IF; 
        IF NVL(:NEW.CDCAIXACTRL, 'NULL') <> NVL(:OLD.CDCAIXACTRL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCAIXACTRL ' || ' ' || NVL(:NEW.CDCAIXACTRL, '');
        END IF; 
        IF NVL(:NEW.VRPEEMITROCO, 99999) <> NVL(:OLD.VRPEEMITROCO, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRPEEMITROCO ' || ' ' || NVL(:NEW.VRPEEMITROCO, '');
        END IF; 
        IF NVL(:NEW.DTINTESTCONS, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.DTINTESTCONS, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTINTESTCONS ' || ' ' || NVL(:NEW.DTINTESTCONS, '');
        END IF; 
        IF NVL(:NEW.DTINITESCONS, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.DTINITESCONS, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTINITESCONS ' || ' ' || NVL(:NEW.DTINITESCONS, '');
        END IF; 
        IF NVL(:NEW.CDFORMATCOD, 'NULL') <> NVL(:OLD.CDFORMATCOD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDFORMATCOD ' || ' ' || NVL(:NEW.CDFORMATCOD, '');
        END IF; 
        IF NVL(:NEW.NRPOSINIOPT, 'NULL') <> NVL(:OLD.NRPOSINIOPT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRPOSINIOPT ' || ' ' || NVL(:NEW.NRPOSINIOPT, '');
        END IF; 
        IF NVL(:NEW.NRPOSFIMOPT, 'NULL') <> NVL(:OLD.NRPOSFIMOPT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRPOSFIMOPT ' || ' ' || NVL(:NEW.NRPOSFIMOPT, '');
        END IF; 
        IF NVL(:NEW.DTULTATUPAVN, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.DTULTATUPAVN, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTULTATUPAVN ' || ' ' || NVL(:NEW.DTULTATUPAVN, '');
        END IF; 
        IF NVL(:NEW.DTINICONSTOT, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.DTINICONSTOT, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTINICONSTOT ' || ' ' || NVL(:NEW.DTINICONSTOT, '');
        END IF; 
        IF NVL(:NEW.IDTIPMAPRESU, 'NULL') <> NVL(:OLD.IDTIPMAPRESU, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDTIPMAPRESU ' || ' ' || NVL(:NEW.IDTIPMAPRESU, '');
        END IF; 
        IF NVL(:NEW.IDENTRSAIDOP, 'NULL') <> NVL(:OLD.IDENTRSAIDOP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDENTRSAIDOP ' || ' ' || NVL(:NEW.IDENTRSAIDOP, '');
        END IF; 
        IF NVL(:NEW.CDTIPOOPER, 'NULL') <> NVL(:OLD.CDTIPOOPER, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOOPER ' || ' ' || NVL(:NEW.CDTIPOOPER, '');
        END IF; 
        IF NVL(:NEW.IDACRIMPOSTO, 'NULL') <> NVL(:OLD.IDACRIMPOSTO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDACRIMPOSTO ' || ' ' || NVL(:NEW.IDACRIMPOSTO, '');
        END IF; 
        IF NVL(:NEW.CDOPERADOR, 'NULL') <> NVL(:OLD.CDOPERADOR, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDOPERADOR ' || ' ' || NVL(:NEW.CDOPERADOR, '');
        END IF; 
        IF NVL(:NEW.CDPRODTAXSER, 'NULL') <> NVL(:OLD.CDPRODTAXSER, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDPRODTAXSER ' || ' ' || NVL(:NEW.CDPRODTAXSER, '');
        END IF; 
        IF NVL(:NEW.CDFILIALEXT, 'NULL') <> NVL(:OLD.CDFILIALEXT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDFILIALEXT ' || ' ' || NVL(:NEW.CDFILIALEXT, '');
        END IF; 
        IF NVL(:NEW.CDVERBACONS, 'NULL') <> NVL(:OLD.CDVERBACONS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDVERBACONS ' || ' ' || NVL(:NEW.CDVERBACONS, '');
        END IF; 
        IF NVL(:NEW.CDVERBAEXCE, 'NULL') <> NVL(:OLD.CDVERBAEXCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDVERBAEXCE ' || ' ' || NVL(:NEW.CDVERBAEXCE, '');
        END IF; 
        IF NVL(:NEW.IDCALCVREXCE, 'NULL') <> NVL(:OLD.IDCALCVREXCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCALCVREXCE ' || ' ' || NVL(:NEW.IDCALCVREXCE, '');
        END IF; 
        IF NVL(:NEW.VRREFNEGCLIE, 99999) <> NVL(:OLD.VRREFNEGCLIE, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRREFNEGCLIE ' || ' ' || NVL(:NEW.VRREFNEGCLIE, '');
        END IF; 
        IF NVL(:NEW.IDSALDOINICUPOM, 'NULL') <> NVL(:OLD.IDSALDOINICUPOM, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDSALDOINICUPOM ' || ' ' || NVL(:NEW.IDSALDOINICUPOM, '');
        END IF; 
        IF NVL(:NEW.IDPREVCONSPDV, 'NULL') <> NVL(:OLD.IDPREVCONSPDV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPREVCONSPDV ' || ' ' || NVL(:NEW.IDPREVCONSPDV, '');
        END IF; 
        IF NVL(:NEW.CDSERIECNTREC, 'NULL') <> NVL(:OLD.CDSERIECNTREC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDSERIECNTREC ' || ' ' || NVL(:NEW.CDSERIECNTREC, '');
        END IF; 
        IF NVL(:NEW.CDTPOPERCNTREC, 'NULL') <> NVL(:OLD.CDTPOPERCNTREC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPOPERCNTREC ' || ' ' || NVL(:NEW.CDTPOPERCNTREC, '');
        END IF; 
        IF NVL(:NEW.CDREDUCONT, 'NULL') <> NVL(:OLD.CDREDUCONT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDREDUCONT ' || ' ' || NVL(:NEW.CDREDUCONT, '');
        END IF; 
        IF NVL(:NEW.CDTPBAIXAREC, 'NULL') <> NVL(:OLD.CDTPBAIXAREC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPBAIXAREC ' || ' ' || NVL(:NEW.CDTPBAIXAREC, '');
        END IF; 
        IF NVL(:NEW.IDGERACAOTC, 'NULL') <> NVL(:OLD.IDGERACAOTC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERACAOTC ' || ' ' || NVL(:NEW.IDGERACAOTC, '');
        END IF; 
        IF NVL(:NEW.IDIMPSALDOCUPOM, 'NULL') <> NVL(:OLD.IDIMPSALDOCUPOM, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPSALDOCUPOM ' || ' ' || NVL(:NEW.IDIMPSALDOCUPOM, '');
        END IF; 
        IF NVL(:NEW.IDPERCONVESTNEG, 'NULL') <> NVL(:OLD.IDPERCONVESTNEG, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERCONVESTNEG ' || ' ' || NVL(:NEW.IDPERCONVESTNEG, '');
        END IF; 
        IF NVL(:NEW.IDUTILMODPROD, 'NULL') <> NVL(:OLD.IDUTILMODPROD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILMODPROD ' || ' ' || NVL(:NEW.IDUTILMODPROD, '');
        END IF; 
        IF NVL(:NEW.NRDIASVERMOVCLI, 99999) <> NVL(:OLD.NRDIASVERMOVCLI, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIASVERMOVCLI ' || ' ' || NVL(:NEW.NRDIASVERMOVCLI, '');
        END IF; 
        IF NVL(:NEW.IDUTCONFCADCONS, 'NULL') <> NVL(:OLD.IDUTCONFCADCONS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTCONFCADCONS ' || ' ' || NVL(:NEW.IDUTCONFCADCONS, '');
        END IF; 
        IF NVL(:NEW.IDRECBOLETBANC, 'NULL') <> NVL(:OLD.IDRECBOLETBANC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDRECBOLETBANC ' || ' ' || NVL(:NEW.IDRECBOLETBANC, '');
        END IF; 
        IF NVL(:NEW.IDRECBANCOITAU, 'NULL') <> NVL(:OLD.IDRECBANCOITAU, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDRECBANCOITAU ' || ' ' || NVL(:NEW.IDRECBANCOITAU, '');
        END IF; 
        IF NVL(:NEW.IDRECBANCOBRADE, 'NULL') <> NVL(:OLD.IDRECBANCOBRADE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDRECBANCOBRADE ' || ' ' || NVL(:NEW.IDRECBANCOBRADE, '');
        END IF; 
        IF NVL(:NEW.IDCONSREDZMECF, 'NULL') <> NVL(:OLD.IDCONSREDZMECF, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSREDZMECF ' || ' ' || NVL(:NEW.IDCONSREDZMECF, '');
        END IF; 
        IF NVL(:NEW.IDCONSTCFECDIA, 'NULL') <> NVL(:OLD.IDCONSTCFECDIA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSTCFECDIA ' || ' ' || NVL(:NEW.IDCONSTCFECDIA, '');
        END IF; 
        IF NVL(:NEW.IDPERLANCANTDP, 'NULL') <> NVL(:OLD.IDPERLANCANTDP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERLANCANTDP ' || ' ' || NVL(:NEW.IDPERLANCANTDP, '');
        END IF; 
        IF NVL(:NEW.NRDIAANTLANC, 99999) <> NVL(:OLD.NRDIAANTLANC, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIAANTLANC ' || ' ' || NVL(:NEW.NRDIAANTLANC, '');
        END IF; 
        IF NVL(:NEW.IDPERLANCPOSDP, 'NULL') <> NVL(:OLD.IDPERLANCPOSDP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERLANCPOSDP ' || ' ' || NVL(:NEW.IDPERLANCPOSDP, '');
        END IF; 
        IF NVL(:NEW.NRDIAPOSLANC, 99999) <> NVL(:OLD.NRDIAPOSLANC, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIAPOSLANC ' || ' ' || NVL(:NEW.NRDIAPOSLANC, '');
        END IF; 
        IF NVL(:NEW.DTPROCVND, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.DTPROCVND, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTPROCVND ' || ' ' || NVL(:NEW.DTPROCVND, '');
        END IF; 
        IF NVL(:NEW.NRORG, 99999) <> NVL(:OLD.NRORG, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRORG ' || ' ' || NVL(:NEW.NRORG, '');
        END IF; 
        IF NVL(:NEW.DTINCLUSAO, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.DTINCLUSAO, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTINCLUSAO ' || ' ' || NVL(:NEW.DTINCLUSAO, '');
        END IF; 
        IF NVL(:NEW.DTULTATU, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.DTULTATU, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTULTATU ' || ' ' || NVL(:NEW.DTULTATU, '');
        END IF; 
        IF NVL(:NEW.NRORGINCLUSAO, 99999) <> NVL(:OLD.NRORGINCLUSAO, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRORGINCLUSAO ' || ' ' || NVL(:NEW.NRORGINCLUSAO, '');
        END IF; 
        IF NVL(:NEW.CDOPERINCLUSAO, 'NULL') <> NVL(:OLD.CDOPERINCLUSAO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDOPERINCLUSAO ' || ' ' || NVL(:NEW.CDOPERINCLUSAO, '');
        END IF; 
        IF NVL(:NEW.NRORGULTATU, 99999) <> NVL(:OLD.NRORGULTATU, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRORGULTATU ' || ' ' || NVL(:NEW.NRORGULTATU, '');
        END IF; 
        IF NVL(:NEW.CDOPERULTATU, 'NULL') <> NVL(:OLD.CDOPERULTATU, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDOPERULTATU ' || ' ' || NVL(:NEW.CDOPERULTATU, '');
        END IF; 
        IF NVL(:NEW.IDPERCADCONSFCXA, 'NULL') <> NVL(:OLD.IDPERCADCONSFCXA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERCADCONSFCXA ' || ' ' || NVL(:NEW.IDPERCADCONSFCXA, '');
        END IF; 
        IF NVL(:NEW.IDFILUTSITE, 'NULL') <> NVL(:OLD.IDFILUTSITE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDFILUTSITE ' || ' ' || NVL(:NEW.IDFILUTSITE, '');
        END IF; 
        IF NVL(:NEW.VRCONSMAXPER, 99999) <> NVL(:OLD.VRCONSMAXPER, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRCONSMAXPER ' || ' ' || NVL(:NEW.VRCONSMAXPER, '');
        END IF; 
        IF NVL(:NEW.IDPARIMPRLIMVDC, 'NULL') <> NVL(:OLD.IDPARIMPRLIMVDC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPARIMPRLIMVDC ' || ' ' || NVL(:NEW.IDPARIMPRLIMVDC, '');
        END IF; 
        IF NVL(:NEW.DSMD5FORSALE, 'NULL') <> NVL(:OLD.DSMD5FORSALE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSMD5FORSALE ' || ' ' || NVL(:NEW.DSMD5FORSALE, '');
        END IF; 
        IF NVL(:NEW.IDATUIDMCLI, 'NULL') <> NVL(:OLD.IDATUIDMCLI, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDATUIDMCLI ' || ' ' || NVL(:NEW.IDATUIDMCLI, '');
        END IF; 
        IF NVL(:NEW.IDGERAARQXMLINT, 'NULL') <> NVL(:OLD.IDGERAARQXMLINT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERAARQXMLINT ' || ' ' || NVL(:NEW.IDGERAARQXMLINT, '');
        END IF; 
        IF NVL(:NEW.DSDIRARQXMLINT, 'NULL') <> NVL(:OLD.DSDIRARQXMLINT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSDIRARQXMLINT ' || ' ' || NVL(:NEW.DSDIRARQXMLINT, '');
        END IF; 
        IF NVL(:NEW.IDIMPBLOLANCNEG, 'NULL') <> NVL(:OLD.IDIMPBLOLANCNEG, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPBLOLANCNEG ' || ' ' || NVL(:NEW.IDIMPBLOLANCNEG, '');
        END IF; 
        IF NVL(:NEW.IDGERANFVENPROD, 'NULL') <> NVL(:OLD.IDGERANFVENPROD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERANFVENPROD ' || ' ' || NVL(:NEW.IDGERANFVENPROD, '');
        END IF; 
        IF NVL(:NEW.IDATUIDVCAT, 'NULL') <> NVL(:OLD.IDATUIDVCAT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDATUIDVCAT ' || ' ' || NVL(:NEW.IDATUIDVCAT, '');
        END IF; 
        IF NVL(:NEW.HRINI1DAYPART, 'NULL') <> NVL(:OLD.HRINI1DAYPART, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRINI1DAYPART ' || ' ' || NVL(:NEW.HRINI1DAYPART, '');
        END IF; 
        IF NVL(:NEW.HRFIN1DAYPART, 'NULL') <> NVL(:OLD.HRFIN1DAYPART, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRFIN1DAYPART ' || ' ' || NVL(:NEW.HRFIN1DAYPART, '');
        END IF; 
        IF NVL(:NEW.HRINI2DAYPART, 'NULL') <> NVL(:OLD.HRINI2DAYPART, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRINI2DAYPART ' || ' ' || NVL(:NEW.HRINI2DAYPART, '');
        END IF; 
        IF NVL(:NEW.HRFIN2DAYPART, 'NULL') <> NVL(:OLD.HRFIN2DAYPART, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRFIN2DAYPART ' || ' ' || NVL(:NEW.HRFIN2DAYPART, '');
        END IF; 
        IF NVL(:NEW.HRINI3DAYPART, 'NULL') <> NVL(:OLD.HRINI3DAYPART, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRINI3DAYPART ' || ' ' || NVL(:NEW.HRINI3DAYPART, '');
        END IF; 
        IF NVL(:NEW.HRFIN3DAYPART, 'NULL') <> NVL(:OLD.HRFIN3DAYPART, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRFIN3DAYPART ' || ' ' || NVL(:NEW.HRFIN3DAYPART, '');
        END IF; 
        IF NVL(:NEW.HRINI4DAYPART, 'NULL') <> NVL(:OLD.HRINI4DAYPART, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRINI4DAYPART ' || ' ' || NVL(:NEW.HRINI4DAYPART, '');
        END IF; 
        IF NVL(:NEW.HRFIN4DAYPART, 'NULL') <> NVL(:OLD.HRFIN4DAYPART, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRFIN4DAYPART ' || ' ' || NVL(:NEW.HRFIN4DAYPART, '');
        END IF; 
        IF NVL(:NEW.CDINTEGRADOTZ, 'NULL') <> NVL(:OLD.CDINTEGRADOTZ, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDINTEGRADOTZ ' || ' ' || NVL(:NEW.CDINTEGRADOTZ, '');
        END IF; 
        IF NVL(:NEW.IDTPAPUFIL, 'NULL') <> NVL(:OLD.IDTPAPUFIL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDTPAPUFIL ' || ' ' || NVL(:NEW.IDTPAPUFIL, '');
        END IF; 
        IF NVL(:NEW.NRDIAFECHAFOLHA, 'NULL') <> NVL(:OLD.NRDIAFECHAFOLHA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIAFECHAFOLHA ' || ' ' || NVL(:NEW.NRDIAFECHAFOLHA, '');
        END IF; 
        IF NVL(:NEW.IDEXCONSATFIL, 'NULL') <> NVL(:OLD.IDEXCONSATFIL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDEXCONSATFIL ' || ' ' || NVL(:NEW.IDEXCONSATFIL, '');
        END IF; 
        IF NVL(:NEW.DSDIRARQDOTZ, 'NULL') <> NVL(:OLD.DSDIRARQDOTZ, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSDIRARQDOTZ ' || ' ' || NVL(:NEW.DSDIRARQDOTZ, '');
        END IF; 
        IF NVL(:NEW.IDAMBTRABNFCE, 'NULL') <> NVL(:OLD.IDAMBTRABNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAMBTRABNFCE ' || ' ' || NVL(:NEW.IDAMBTRABNFCE, '');
        END IF; 
        IF NVL(:NEW.NRCERTDIGNFCE, 'NULL') <> NVL(:OLD.NRCERTDIGNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRCERTDIGNFCE ' || ' ' || NVL(:NEW.NRCERTDIGNFCE, '');
        END IF; 
        IF NVL(:NEW.IDCANCEXTNFCE, 'NULL') <> NVL(:OLD.IDCANCEXTNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCANCEXTNFCE ' || ' ' || NVL(:NEW.IDCANCEXTNFCE, '');
        END IF; 
        IF NVL(:NEW.IDGERALOGNFCE, 'NULL') <> NVL(:OLD.IDGERALOGNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERALOGNFCE ' || ' ' || NVL(:NEW.IDGERALOGNFCE, '');
        END IF; 
        IF NVL(:NEW.DSDIRARQLOGNFCE, 'NULL') <> NVL(:OLD.DSDIRARQLOGNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSDIRARQLOGNFCE ' || ' ' || NVL(:NEW.DSDIRARQLOGNFCE, '');
        END IF; 
        IF NVL(:NEW.IDTPTAXAROYA, 'NULL') <> NVL(:OLD.IDTPTAXAROYA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDTPTAXAROYA ' || ' ' || NVL(:NEW.IDTPTAXAROYA, '');
        END IF; 
        IF NVL(:NEW.IDTPTAXAMARK, 'NULL') <> NVL(:OLD.IDTPTAXAMARK, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDTPTAXAMARK ' || ' ' || NVL(:NEW.IDTPTAXAMARK, '');
        END IF; 
        IF NVL(:NEW.DTFECHAFRANQ, 'NULL') <> NVL(:OLD.DTFECHAFRANQ, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTFECHAFRANQ ' || ' ' || NVL(:NEW.DTFECHAFRANQ, '');
        END IF; 
        IF NVL(:NEW.VRPERCROYALT, 99999) <> NVL(:OLD.VRPERCROYALT, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRPERCROYALT ' || ' ' || NVL(:NEW.VRPERCROYALT, '');
        END IF; 
        IF NVL(:NEW.VRFIXOROYALT, 99999) <> NVL(:OLD.VRFIXOROYALT, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRFIXOROYALT ' || ' ' || NVL(:NEW.VRFIXOROYALT, '');
        END IF; 
        IF NVL(:NEW.VRPERCMARKET, 99999) <> NVL(:OLD.VRPERCMARKET, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRPERCMARKET ' || ' ' || NVL(:NEW.VRPERCMARKET, '');
        END IF; 
        IF NVL(:NEW.VRFIXOMARKET, 99999) <> NVL(:OLD.VRFIXOMARKET, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRFIXOMARKET ' || ' ' || NVL(:NEW.VRFIXOMARKET, '');
        END IF; 
        IF NVL(:NEW.TPVENCNF, 'NULL') <> NVL(:OLD.TPVENCNF, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'TPVENCNF ' || ' ' || NVL(:NEW.TPVENCNF, '');
        END IF; 
        IF NVL(:NEW.DIAVENCNF, 'NULL') <> NVL(:OLD.DIAVENCNF, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DIAVENCNF ' || ' ' || NVL(:NEW.DIAVENCNF, '');
        END IF; 
        IF NVL(:NEW.CDCLIFRAN, 'NULL') <> NVL(:OLD.CDCLIFRAN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCLIFRAN ' || ' ' || NVL(:NEW.CDCLIFRAN, '');
        END IF; 
        IF NVL(:NEW.NMRAZSOCCLIEFRAN, 'NULL') <> NVL(:OLD.NMRAZSOCCLIEFRAN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NMRAZSOCCLIEFRAN ' || ' ' || NVL(:NEW.NMRAZSOCCLIEFRAN, '');
        END IF; 
        IF NVL(:NEW.CDPRODUTOROY, 'NULL') <> NVL(:OLD.CDPRODUTOROY, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDPRODUTOROY ' || ' ' || NVL(:NEW.CDPRODUTOROY, '');
        END IF; 
        IF NVL(:NEW.NMPRODUTOROY, 'NULL') <> NVL(:OLD.NMPRODUTOROY, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NMPRODUTOROY ' || ' ' || NVL(:NEW.NMPRODUTOROY, '');
        END IF; 
        IF NVL(:NEW.CDPRODUTOMAR, 'NULL') <> NVL(:OLD.CDPRODUTOMAR, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDPRODUTOMAR ' || ' ' || NVL(:NEW.CDPRODUTOMAR, '');
        END IF; 
        IF NVL(:NEW.NMPRODUTOMAR, 'NULL') <> NVL(:OLD.NMPRODUTOMAR, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NMPRODUTOMAR ' || ' ' || NVL(:NEW.NMPRODUTOMAR, '');
        END IF; 
        IF NVL(:NEW.CDSERIEFRAN, 'NULL') <> NVL(:OLD.CDSERIEFRAN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDSERIEFRAN ' || ' ' || NVL(:NEW.CDSERIEFRAN, '');
        END IF; 
        IF NVL(:NEW.DSSERIEFRAN, 'NULL') <> NVL(:OLD.DSSERIEFRAN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSSERIEFRAN ' || ' ' || NVL(:NEW.DSSERIEFRAN, '');
        END IF; 
        IF NVL(:NEW.CDTIPOOPERFRAN, 'NULL') <> NVL(:OLD.CDTIPOOPERFRAN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOOPERFRAN ' || ' ' || NVL(:NEW.CDTIPOOPERFRAN, '');
        END IF; 
        IF NVL(:NEW.NMTIPOOPERFRAN, 'NULL') <> NVL(:OLD.NMTIPOOPERFRAN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NMTIPOOPERFRAN ' || ' ' || NVL(:NEW.NMTIPOOPERFRAN, '');
        END IF; 
        IF NVL(:NEW.IDUTILCONTAB, 'NULL') <> NVL(:OLD.IDUTILCONTAB, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILCONTAB ' || ' ' || NVL(:NEW.IDUTILCONTAB, '');
        END IF; 
        IF NVL(:NEW.IDCONCREDDF, 'NULL') <> NVL(:OLD.IDCONCREDDF, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONCREDDF ' || ' ' || NVL(:NEW.IDCONCREDDF, '');
        END IF; 
        IF NVL(:NEW.IDETIQZEBRA, 'NULL') <> NVL(:OLD.IDETIQZEBRA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDETIQZEBRA ' || ' ' || NVL(:NEW.IDETIQZEBRA, '');
        END IF; 
        IF NVL(:NEW.NRDIAVALTURCAIX, 'NULL') <> NVL(:OLD.NRDIAVALTURCAIX, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIAVALTURCAIX ' || ' ' || NVL(:NEW.NRDIAVALTURCAIX, '');
        END IF; 
        IF NVL(:NEW.IDBLOQCONSOLIDA, 'NULL') <> NVL(:OLD.IDBLOQCONSOLIDA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDBLOQCONSOLIDA ' || ' ' || NVL(:NEW.IDBLOQCONSOLIDA, '');
        END IF; 
        IF NVL(:NEW.IDCONSISTECONSO, 'NULL') <> NVL(:OLD.IDCONSISTECONSO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSISTECONSO ' || ' ' || NVL(:NEW.IDCONSISTECONSO, '');
        END IF; 
        IF NVL(:NEW.IDINTHOTEL, 'NULL') <> NVL(:OLD.IDINTHOTEL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDINTHOTEL ' || ' ' || NVL(:NEW.IDINTHOTEL, '');
        END IF; 
        IF NVL(:NEW.DSSTRINGHOTEL, 'NULL') <> NVL(:OLD.DSSTRINGHOTEL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSSTRINGHOTEL ' || ' ' || NVL(:NEW.DSSTRINGHOTEL, '');
        END IF; 
        IF NVL(:NEW.CDCODSCONSPROD, 'NULL') <> NVL(:OLD.CDCODSCONSPROD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCODSCONSPROD ' || ' ' || NVL(:NEW.CDCODSCONSPROD, '');
        END IF; 
        IF NVL(:NEW.CDCODSCONSHOMO, 'NULL') <> NVL(:OLD.CDCODSCONSHOMO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCODSCONSHOMO ' || ' ' || NVL(:NEW.CDCODSCONSHOMO, '');
        END IF; 
        IF NVL(:NEW.CDURLWSNFC, 'NULL') <> NVL(:OLD.CDURLWSNFC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDURLWSNFC ' || ' ' || NVL(:NEW.CDURLWSNFC, '');
        END IF; 
        IF NVL(:NEW.CDVINCSAT, 'NULL') <> NVL(:OLD.CDVINCSAT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDVINCSAT ' || ' ' || NVL(:NEW.CDVINCSAT, '');
        END IF; 
        IF NVL(:NEW.NRMINEXPVENDA, 'NULL') <> NVL(:OLD.NRMINEXPVENDA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRMINEXPVENDA ' || ' ' || NVL(:NEW.NRMINEXPVENDA, '');
        END IF; 
        IF NVL(:NEW.IDSOLICITADOTZ, 'NULL') <> NVL(:OLD.IDSOLICITADOTZ, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDSOLICITADOTZ ' || ' ' || NVL(:NEW.IDSOLICITADOTZ, '');
        END IF; 
        IF NVL(:NEW.IDSOLICITANSU, 'NULL') <> NVL(:OLD.IDSOLICITANSU, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDSOLICITANSU ' || ' ' || NVL(:NEW.IDSOLICITANSU, '');
        END IF; 
        IF NVL(:NEW.IDINTEGRAEEXTRA, 'NULL') <> NVL(:OLD.IDINTEGRAEEXTRA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDINTEGRAEEXTRA ' || ' ' || NVL(:NEW.IDINTEGRAEEXTRA, '');
        END IF; 
        IF NVL(:NEW.CDVENDEDOR, 'NULL') <> NVL(:OLD.CDVENDEDOR, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDVENDEDOR ' || ' ' || NVL(:NEW.CDVENDEDOR, '');
        END IF; 
        IF NVL(:NEW.IDENVIAPEDKDS, 'NULL') <> NVL(:OLD.IDENVIAPEDKDS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDENVIAPEDKDS ' || ' ' || NVL(:NEW.IDENVIAPEDKDS, '');
        END IF; 
        IF NVL(:NEW.CDIDTOKENHOMO, 'NULL') <> NVL(:OLD.CDIDTOKENHOMO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDIDTOKENHOMO ' || ' ' || NVL(:NEW.CDIDTOKENHOMO, '');
        END IF; 
        IF NVL(:NEW.CDIDTOKENPROD, 'NULL') <> NVL(:OLD.CDIDTOKENPROD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDIDTOKENPROD ' || ' ' || NVL(:NEW.CDIDTOKENPROD, '');
        END IF; 
        IF NVL(:NEW.CDAJDIFTXADMREC, 'NULL') <> NVL(:OLD.CDAJDIFTXADMREC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDAJDIFTXADMREC ' || ' ' || NVL(:NEW.CDAJDIFTXADMREC, '');
        END IF; 
        IF NVL(:NEW.DSRECOMENDNUTRI, 'NULL') <> NVL(:OLD.DSRECOMENDNUTRI, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSRECOMENDNUTRI ' || ' ' || NVL(:NEW.DSRECOMENDNUTRI, '');
        END IF; 
        IF NVL(:NEW.NRTAMARQXML, 'NULL') <> NVL(:OLD.NRTAMARQXML, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRTAMARQXML ' || ' ' || NVL(:NEW.NRTAMARQXML, '');
        END IF; 
        IF NVL(:NEW.CDTPAJUSANGRACR, 'NULL') <> NVL(:OLD.CDTPAJUSANGRACR, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPAJUSANGRACR ' || ' ' || NVL(:NEW.CDTPAJUSANGRACR, '');
        END IF; 
        IF NVL(:NEW.CDTPAJUSANGRRED, 'NULL') <> NVL(:OLD.CDTPAJUSANGRRED, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPAJUSANGRRED ' || ' ' || NVL(:NEW.CDTPAJUSANGRRED, '');
        END IF; 
        IF NVL(:NEW.NRATRAPADRAO, 99999) <> NVL(:OLD.NRATRAPADRAO, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRATRAPADRAO ' || ' ' || NVL(:NEW.NRATRAPADRAO, '');
        END IF; 
        IF NVL(:NEW.IDPREVALIDCUPOM, 'NULL') <> NVL(:OLD.IDPREVALIDCUPOM, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPREVALIDCUPOM ' || ' ' || NVL(:NEW.IDPREVALIDCUPOM, '');
        END IF; 
        IF NVL(:NEW.IDLOJAESITEFFIL, 'NULL') <> NVL(:OLD.IDLOJAESITEFFIL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDLOJAESITEFFIL ' || ' ' || NVL(:NEW.IDLOJAESITEFFIL, '');
        END IF; 
        IF NVL(:NEW.CDLOJAESITEFFIL, 'NULL') <> NVL(:OLD.CDLOJAESITEFFIL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDLOJAESITEFFIL ' || ' ' || NVL(:NEW.CDLOJAESITEFFIL, '');
        END IF; 
        IF NVL(:NEW.IDAGRUPVALORCLI, 'NULL') <> NVL(:OLD.IDAGRUPVALORCLI, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAGRUPVALORCLI ' || ' ' || NVL(:NEW.IDAGRUPVALORCLI, '');
        END IF; 
        IF NVL(:NEW.CDTIPORETI, 'NULL') <> NVL(:OLD.CDTIPORETI, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPORETI ' || ' ' || NVL(:NEW.CDTIPORETI, '');
        END IF; 
        IF NVL(:NEW.IDPERMANUTVEN, 'NULL') <> NVL(:OLD.IDPERMANUTVEN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERMANUTVEN ' || ' ' || NVL(:NEW.IDPERMANUTVEN, '');
        END IF; 
        IF NVL(:NEW.NRSEGLIMPEZATAA, 'NULL') <> NVL(:OLD.NRSEGLIMPEZATAA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRSEGLIMPEZATAA ' || ' ' || NVL(:NEW.NRSEGLIMPEZATAA, '');
        END IF; 
        IF NVL(:NEW.DSARQXMLCATR, 'NULL') <> NVL(:OLD.DSARQXMLCATR, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSARQXMLCATR ' || ' ' || NVL(:NEW.DSARQXMLCATR, '');
        END IF; 
        IF NVL(:NEW.IDCPFPINPAD, 'NULL') <> NVL(:OLD.IDCPFPINPAD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCPFPINPAD ' || ' ' || NVL(:NEW.IDCPFPINPAD, '');
        END IF; 
        IF NVL(:NEW.IDINFOCPFPINPAD, 'NULL') <> NVL(:OLD.IDINFOCPFPINPAD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDINFOCPFPINPAD ' || ' ' || NVL(:NEW.IDINFOCPFPINPAD, '');
        END IF; 
        IF NVL(:NEW.IDIMPLOGONF, 'NULL') <> NVL(:OLD.IDIMPLOGONF, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPLOGONF ' || ' ' || NVL(:NEW.IDIMPLOGONF, '');
        END IF; 
        IF NVL(:NEW.NRPOSNVBEMA, 'NULL') <> NVL(:OLD.NRPOSNVBEMA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRPOSNVBEMA ' || ' ' || NVL(:NEW.NRPOSNVBEMA, '');
        END IF; 
        IF NVL(:NEW.NRPOSNV1EPSON, 'NULL') <> NVL(:OLD.NRPOSNV1EPSON, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRPOSNV1EPSON ' || ' ' || NVL(:NEW.NRPOSNV1EPSON, '');
        END IF; 
        IF NVL(:NEW.NRPOSNV2EPSON, 'NULL') <> NVL(:OLD.NRPOSNV2EPSON, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRPOSNV2EPSON ' || ' ' || NVL(:NEW.NRPOSNV2EPSON, '');
        END IF; 
        IF NVL(:NEW.VRMINSANGRIA, 99999) <> NVL(:OLD.VRMINSANGRIA, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRMINSANGRIA ' || ' ' || NVL(:NEW.VRMINSANGRIA, '');
        END IF; 
        IF NVL(:NEW.VRMAXSANGRIA, 99999) <> NVL(:OLD.VRMAXSANGRIA, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRMAXSANGRIA ' || ' ' || NVL(:NEW.VRMAXSANGRIA, '');
        END IF; 
        IF NVL(:NEW.VRTXENTREGA, 99999) <> NVL(:OLD.VRTXENTREGA, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRTXENTREGA ' || ' ' || NVL(:NEW.VRTXENTREGA, '');
        END IF; 
        IF NVL(:NEW.NRTEMPMAXENTR, 99999) <> NVL(:OLD.NRTEMPMAXENTR, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRTEMPMAXENTR ' || ' ' || NVL(:NEW.NRTEMPMAXENTR, '');
        END IF; 
        IF NVL(:NEW.IDCONSCAMPFIDEL, 'NULL') <> NVL(:OLD.IDCONSCAMPFIDEL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSCAMPFIDEL ' || ' ' || NVL(:NEW.IDCONSCAMPFIDEL, '');
        END IF; 
        IF NVL(:NEW.IDIMPTXSERV, 'NULL') <> NVL(:OLD.IDIMPTXSERV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPTXSERV ' || ' ' || NVL(:NEW.IDIMPTXSERV, '');
        END IF; 
        IF NVL(:NEW.IDUTLIBERAPROV, 'NULL') <> NVL(:OLD.IDUTLIBERAPROV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTLIBERAPROV ' || ' ' || NVL(:NEW.IDUTLIBERAPROV, '');
        END IF; 
        IF NVL(:NEW.IDUTFECHAUTO, 'NULL') <> NVL(:OLD.IDUTFECHAUTO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTFECHAUTO ' || ' ' || NVL(:NEW.IDUTFECHAUTO, '');
        END IF; 
        IF NVL(:NEW.IDFECHACUPOM, 'NULL') <> NVL(:OLD.IDFECHACUPOM, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDFECHACUPOM ' || ' ' || NVL(:NEW.IDFECHACUPOM, '');
        END IF; 
        IF NVL(:NEW.QTDMAXDIGNSU, 'NULL') <> NVL(:OLD.QTDMAXDIGNSU, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'QTDMAXDIGNSU ' || ' ' || NVL(:NEW.QTDMAXDIGNSU, '');
        END IF; 
        IF NVL(:NEW.IDAGRUITEMVEN, 'NULL') <> NVL(:OLD.IDAGRUITEMVEN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAGRUITEMVEN ' || ' ' || NVL(:NEW.IDAGRUITEMVEN, '');
        END IF; 
        IF NVL(:NEW.IDUTLQTDPED, 'NULL') <> NVL(:OLD.IDUTLQTDPED, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTLQTDPED ' || ' ' || NVL(:NEW.IDUTLQTDPED, '');
        END IF; 
        IF NVL(:NEW.CDSETOR, 'NULL') <> NVL(:OLD.CDSETOR, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDSETOR ' || ' ' || NVL(:NEW.CDSETOR, '');
        END IF; 
        IF NVL(:NEW.IDESTTEMPOREAL, 'NULL') <> NVL(:OLD.IDESTTEMPOREAL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDESTTEMPOREAL ' || ' ' || NVL(:NEW.IDESTTEMPOREAL, '');
        END IF; 
        IF NVL(:NEW.IDENVIACDBARXML, 'NULL') <> NVL(:OLD.IDENVIACDBARXML, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDENVIACDBARXML ' || ' ' || NVL(:NEW.IDENVIACDBARXML, '');
        END IF; 
        IF NVL(:NEW.IDTRANSAUTONFCE, 'NULL') <> NVL(:OLD.IDTRANSAUTONFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDTRANSAUTONFCE ' || ' ' || NVL(:NEW.IDTRANSAUTONFCE, '');
        END IF; 
        IF NVL(:NEW.IDHRTRANSAUTO, 'NULL') <> NVL(:OLD.IDHRTRANSAUTO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDHRTRANSAUTO ' || ' ' || NVL(:NEW.IDHRTRANSAUTO, '');
        END IF; 
        IF NVL(:NEW.HRTRANSAUTO, 'NULL') <> NVL(:OLD.HRTRANSAUTO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRTRANSAUTO ' || ' ' || NVL(:NEW.HRTRANSAUTO, '');
        END IF; 
        IF NVL(:NEW.DSDIRARQPHP, 'NULL') <> NVL(:OLD.DSDIRARQPHP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSDIRARQPHP ' || ' ' || NVL(:NEW.DSDIRARQPHP, '');
        END IF; 
        IF NVL(:NEW.DSDIRINSTALPHP, 'NULL') <> NVL(:OLD.DSDIRINSTALPHP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSDIRINSTALPHP ' || ' ' || NVL(:NEW.DSDIRINSTALPHP, '');
        END IF; 
        IF NVL(:NEW.VRMINPEDIDO, 99999) <> NVL(:OLD.VRMINPEDIDO, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRMINPEDIDO ' || ' ' || NVL(:NEW.VRMINPEDIDO, '');
        END IF; 
        IF NVL(:NEW.IDCONTTXSERVSEP, 'NULL') <> NVL(:OLD.IDCONTTXSERVSEP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONTTXSERVSEP ' || ' ' || NVL(:NEW.IDCONTTXSERVSEP, '');
        END IF; 
        IF NVL(:NEW.CDTPAJTXSERV, 'NULL') <> NVL(:OLD.CDTPAJTXSERV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPAJTXSERV ' || ' ' || NVL(:NEW.CDTPAJTXSERV, '');
        END IF; 
        IF NVL(:NEW.VRTAXAADMISERV, 99999) <> NVL(:OLD.VRTAXAADMISERV, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRTAXAADMISERV ' || ' ' || NVL(:NEW.VRTAXAADMISERV, '');
        END IF; 
        IF NVL(:NEW.CDTPAJTXADMSERV, 'NULL') <> NVL(:OLD.CDTPAJTXADMSERV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPAJTXADMSERV ' || ' ' || NVL(:NEW.CDTPAJTXADMSERV, '');
        END IF; 
        IF NVL(:NEW.IDVISUPRODNEG, 'NULL') <> NVL(:OLD.IDVISUPRODNEG, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDVISUPRODNEG ' || ' ' || NVL(:NEW.IDVISUPRODNEG, '');
        END IF; 
        IF NVL(:NEW.CDCLIENTEPADFIS, 'NULL') <> NVL(:OLD.CDCLIENTEPADFIS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCLIENTEPADFIS ' || ' ' || NVL(:NEW.CDCLIENTEPADFIS, '');
        END IF; 
        IF NVL(:NEW.IDGERAMRNUMREDZ, 'NULL') <> NVL(:OLD.IDGERAMRNUMREDZ, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERAMRNUMREDZ ' || ' ' || NVL(:NEW.IDGERAMRNUMREDZ, '');
        END IF; 
        IF NVL(:NEW.CDCHAVACESVALI, 'NULL') <> NVL(:OLD.CDCHAVACESVALI, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCHAVACESVALI ' || ' ' || NVL(:NEW.CDCHAVACESVALI, '');
        END IF; 
        IF NVL(:NEW.CDCHAVEREQUI, 'NULL') <> NVL(:OLD.CDCHAVEREQUI, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCHAVEREQUI ' || ' ' || NVL(:NEW.CDCHAVEREQUI, '');
        END IF; 
        IF NVL(:NEW.NRMAXPESMES, 'NULL') <> NVL(:OLD.NRMAXPESMES, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRMAXPESMES ' || ' ' || NVL(:NEW.NRMAXPESMES, '');
        END IF; 
        IF NVL(:NEW.DSWSINTEGRAPAGER, 'NULL') <> NVL(:OLD.DSWSINTEGRAPAGER, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSWSINTEGRAPAGER ' || ' ' || NVL(:NEW.DSWSINTEGRAPAGER, '');
        END IF; 
        IF NVL(:NEW.DSWSINTEGRAAPP, 'NULL') <> NVL(:OLD.DSWSINTEGRAAPP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSWSINTEGRAAPP ' || ' ' || NVL(:NEW.DSWSINTEGRAAPP, '');
        END IF; 
        IF NVL(:NEW.NRDISTANCIAATEND, 99999) <> NVL(:OLD.NRDISTANCIAATEND, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRDISTANCIAATEND ' || ' ' || NVL(:NEW.NRDISTANCIAATEND, '');
        END IF; 
        IF NVL(:NEW.IDATIVO, 'NULL') <> NVL(:OLD.IDATIVO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDATIVO ' || ' ' || NVL(:NEW.IDATIVO, '');
        END IF; 
        IF NVL(:NEW.CDVERSAOXMLNFCE, 'NULL') <> NVL(:OLD.CDVERSAOXMLNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDVERSAOXMLNFCE ' || ' ' || NVL(:NEW.CDVERSAOXMLNFCE, '');
        END IF; 
        /* campo descontinuado
        IF NVL(:NEW.DSEMAILCLUSO, 'NULL') <> NVL(:OLD.DSEMAILCLUSO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSEMAILCLUSO ' || ' ' || NVL(:NEW.DSEMAILCLUSO, '');
        END IF;*/ 
        IF NVL(:NEW.VRPERCCUSTPROD, 99999) <> NVL(:OLD.VRPERCCUSTPROD, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRPERCCUSTPROD ' || ' ' || NVL(:NEW.VRPERCCUSTPROD, '');
        END IF; 
        IF NVL(:NEW.IDUMAVIANFCE, 'NULL') <> NVL(:OLD.IDUMAVIANFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUMAVIANFCE ' || ' ' || NVL(:NEW.IDUMAVIANFCE, '');
        END IF; 
        IF NVL(:NEW.IDCANCAUTNFCE, 'NULL') <> NVL(:OLD.IDCANCAUTNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCANCAUTNFCE ' || ' ' || NVL(:NEW.IDCANCAUTNFCE, '');
        END IF; 
        IF NVL(:NEW.DSJUSTCANCNFCE, 'NULL') <> NVL(:OLD.DSJUSTCANCNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSJUSTCANCNFCE ' || ' ' || NVL(:NEW.DSJUSTCANCNFCE, '');
        END IF; 
        IF NVL(:NEW.CDTABEPRECDLV, 'NULL') <> NVL(:OLD.CDTABEPRECDLV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTABEPRECDLV ' || ' ' || NVL(:NEW.CDTABEPRECDLV, '');
        END IF; 
        IF NVL(:NEW.IDSATCOMP, 'NULL') <> NVL(:OLD.IDSATCOMP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDSATCOMP ' || ' ' || NVL(:NEW.IDSATCOMP, '');
        END IF; 
        IF NVL(:NEW.IDPLATAFORMAPAG, 'NULL') <> NVL(:OLD.IDPLATAFORMAPAG, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPLATAFORMAPAG ' || ' ' || NVL(:NEW.IDPLATAFORMAPAG, '');
        END IF; 
        IF NVL(:NEW.IDPERMITEPAGRETLOJA, 'NULL') <> NVL(:OLD.IDPERMITEPAGRETLOJA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERMITEPAGRETLOJA ' || ' ' || NVL(:NEW.IDPERMITEPAGRETLOJA, '');
        END IF; 
        IF NVL(:NEW.IDUTILTRILOBIT, 'NULL') <> NVL(:OLD.IDUTILTRILOBIT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILTRILOBIT ' || ' ' || NVL(:NEW.IDUTILTRILOBIT, '');
        END IF; 
        IF NVL(:NEW.CDVERSAOQRCNFCE, 'NULL') <> NVL(:OLD.CDVERSAOQRCNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDVERSAOQRCNFCE ' || ' ' || NVL(:NEW.CDVERSAOQRCNFCE, '');
        END IF; 
        IF NVL(:NEW.IDCONDESCTXSERV, 'NULL') <> NVL(:OLD.IDCONDESCTXSERV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONDESCTXSERV ' || ' ' || NVL(:NEW.IDCONDESCTXSERV, '');
        END IF; 
        IF NVL(:NEW.IDKDSHABILITADO, 'NULL') <> NVL(:OLD.IDKDSHABILITADO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDKDSHABILITADO ' || ' ' || NVL(:NEW.IDKDSHABILITADO, '');
        END IF; 
        IF NVL(:NEW.IDUTPRDIFPRCOMB, 'NULL') <> NVL(:OLD.IDUTPRDIFPRCOMB, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTPRDIFPRCOMB ' || ' ' || NVL(:NEW.IDUTPRDIFPRCOMB, '');
        END IF; 
        IF NVL(:NEW.NMARQCERTNFCE, 'NULL') <> NVL(:OLD.NMARQCERTNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NMARQCERTNFCE ' || ' ' || NVL(:NEW.NMARQCERTNFCE, '');
        END IF; 
        IF NVL(:NEW.DSSENHACERTNFCE, 'NULL') <> NVL(:OLD.DSSENHACERTNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSSENHACERTNFCE ' || ' ' || NVL(:NEW.DSSENHACERTNFCE, '');
        END IF; 
        IF NVL(:NEW.WSXMLFISCO, 'NULL') <> NVL(:OLD.WSXMLFISCO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'WSXMLFISCO ' || ' ' || NVL(:NEW.WSXMLFISCO, '');
        END IF; 
        IF NVL(:NEW.IDEXTCONSONLINE, 'NULL') <> NVL(:OLD.IDEXTCONSONLINE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDEXTCONSONLINE ' || ' ' || NVL(:NEW.IDEXTCONSONLINE, '');
        END IF; 
        IF NVL(:NEW.CDURLWSEXTCONS, 'NULL') <> NVL(:OLD.CDURLWSEXTCONS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDURLWSEXTCONS ' || ' ' || NVL(:NEW.CDURLWSEXTCONS, '');
        END IF; 
        IF NVL(:NEW.IDUTLSSL, 'NULL') <> NVL(:OLD.IDUTLSSL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTLSSL ' || ' ' || NVL(:NEW.IDUTLSSL, '');
        END IF; 
        IF NVL(:NEW.CDTIPORECEQRCODE, 'NULL') <> NVL(:OLD.CDTIPORECEQRCODE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPORECEQRCODE ' || ' ' || NVL(:NEW.CDTIPORECEQRCODE, '');
        END IF; 
        IF NVL(:NEW.IDPERVENCONINAT, 'NULL') <> NVL(:OLD.IDPERVENCONINAT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERVENCONINAT ' || ' ' || NVL(:NEW.IDPERVENCONINAT, '');
        END IF; 
        IF NVL(:NEW.IDCONSUBDESFOL, 'NULL') <> NVL(:OLD.IDCONSUBDESFOL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSUBDESFOL ' || ' ' || NVL(:NEW.IDCONSUBDESFOL, '');
        END IF; 
        IF NVL(:NEW.IDUTILBOLNUTRI, 'NULL') <> NVL(:OLD.IDUTILBOLNUTRI, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILBOLNUTRI ' || ' ' || NVL(:NEW.IDUTILBOLNUTRI, '');
        END IF; 
        IF NVL(:NEW.CDGRUPPROD, 'NULL') <> NVL(:OLD.CDGRUPPROD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDGRUPPROD ' || ' ' || NVL(:NEW.CDGRUPPROD, '');
        END IF; 
        IF NVL(:NEW.IDBLOQCXSSERIE, 'NULL') <> NVL(:OLD.IDBLOQCXSSERIE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDBLOQCXSSERIE ' || ' ' || NVL(:NEW.IDBLOQCXSSERIE, '');
        END IF; 
        IF NVL(:NEW.NRTIMEOUTNFCE, 'NULL') <> NVL(:OLD.NRTIMEOUTNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRTIMEOUTNFCE ' || ' ' || NVL(:NEW.NRTIMEOUTNFCE, '');
        END IF; 
        IF NVL(:NEW.IDIMPFLNOTA, 'NULL') <> NVL(:OLD.IDIMPFLNOTA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPFLNOTA ' || ' ' || NVL(:NEW.IDIMPFLNOTA, '');
        END IF; 
        IF NVL(:NEW.IDBLOQTROCSAT, 'NULL') <> NVL(:OLD.IDBLOQTROCSAT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDBLOQTROCSAT ' || ' ' || NVL(:NEW.IDBLOQTROCSAT, '');
        END IF; 
        IF NVL(:NEW.IDIMPMERCBOCA, 'NULL') <> NVL(:OLD.IDIMPMERCBOCA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPMERCBOCA ' || ' ' || NVL(:NEW.IDIMPMERCBOCA, '');
        END IF; 
        IF NVL(:NEW.IDAPUDRFAUT, 'NULL') <> NVL(:OLD.IDAPUDRFAUT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAPUDRFAUT ' || ' ' || NVL(:NEW.IDAPUDRFAUT, '');
        END IF; 
        IF NVL(:NEW.VROBRIGCPFNOTA, 99999) <> NVL(:OLD.VROBRIGCPFNOTA, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VROBRIGCPFNOTA ' || ' ' || NVL(:NEW.VROBRIGCPFNOTA, '');
        END IF; 
        IF NVL(:NEW.IDZERAPEDDLVMEN, 'NULL') <> NVL(:OLD.IDZERAPEDDLVMEN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDZERAPEDDLVMEN ' || ' ' || NVL(:NEW.IDZERAPEDDLVMEN, '');
        END IF; 
        IF NVL(:NEW.IDCOMPPISCOFINS, 'NULL') <> NVL(:OLD.IDCOMPPISCOFINS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCOMPPISCOFINS ' || ' ' || NVL(:NEW.IDCOMPPISCOFINS, '');
        END IF; 
        IF NVL(:NEW.CDCHAVESEGSAT, 'NULL') <> NVL(:OLD.CDCHAVESEGSAT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCHAVESEGSAT ' || ' ' || NVL(:NEW.CDCHAVESEGSAT, '');
        END IF; 
        IF NVL(:NEW.IDCTRLPEDVIAGEM, 'NULL') <> NVL(:OLD.IDCTRLPEDVIAGEM, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCTRLPEDVIAGEM ' || ' ' || NVL(:NEW.IDCTRLPEDVIAGEM, '');
        END IF; 
        IF NVL(:NEW.CDCONSUMIDOR, 'NULL') <> NVL(:OLD.CDCONSUMIDOR, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCONSUMIDOR ' || ' ' || NVL(:NEW.CDCONSUMIDOR, '');
        END IF; 
        IF NVL(:NEW.IDFECHLOJA, 'NULL') <> NVL(:OLD.IDFECHLOJA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDFECHLOJA ' || ' ' || NVL(:NEW.IDFECHLOJA, '');
        END IF; 
        IF NVL(:NEW.IDRESPTECNFCE, 'NULL') <> NVL(:OLD.IDRESPTECNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDRESPTECNFCE ' || ' ' || NVL(:NEW.IDRESPTECNFCE, '');
        END IF; 
        IF NVL(:NEW.CDCONSUMIDPADRAO, 'NULL') <> NVL(:OLD.CDCONSUMIDPADRAO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCONSUMIDPADRAO ' || ' ' || NVL(:NEW.CDCONSUMIDPADRAO, '');
        END IF; 
        IF NVL(:NEW.IDFILENVEMAIL, 'NULL') <> NVL(:OLD.IDFILENVEMAIL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDFILENVEMAIL ' || ' ' || NVL(:NEW.IDFILENVEMAIL, '');
        END IF; 
        IF NVL(:NEW.HRINTSLDNEG, 'NULL') <> NVL(:OLD.HRINTSLDNEG, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRINTSLDNEG ' || ' ' || NVL(:NEW.HRINTSLDNEG, '');
        END IF; 
        IF NVL(:NEW.TXEMAILSLDNEGATIVO, 'NULL') <> NVL(:OLD.TXEMAILSLDNEGATIVO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'TXEMAILSLDNEGATIVO ' || ' ' || NVL(:NEW.TXEMAILSLDNEGATIVO, '');
        END IF; 
        IF NVL(:NEW.IDCONFBIO, 'NULL') <> NVL(:OLD.IDCONFBIO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONFBIO ' || ' ' || NVL(:NEW.IDCONFBIO, '');
        END IF; 
        IF NVL(:NEW.DSIDRESGS, 'NULL') <> NVL(:OLD.DSIDRESGS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSIDRESGS ' || ' ' || NVL(:NEW.DSIDRESGS, '');
        END IF; 
        IF NVL(:NEW.DSSENHARESGS, 'NULL') <> NVL(:OLD.DSSENHARESGS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSSENHARESGS ' || ' ' || NVL(:NEW.DSSENHARESGS, '');
        END IF; 
        IF NVL(:NEW.IDPERLANCAIXFEC, 'NULL') <> NVL(:OLD.IDPERLANCAIXFEC, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERLANCAIXFEC ' || ' ' || NVL(:NEW.IDPERLANCAIXFEC, '');
        END IF; 
        IF NVL(:NEW.IDUTINTCATBIO, 'NULL') <> NVL(:OLD.IDUTINTCATBIO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTINTCATBIO ' || ' ' || NVL(:NEW.IDUTINTCATBIO, '');
        END IF; 
        IF NVL(:NEW.IDDESABTECLATAA, 'NULL') <> NVL(:OLD.IDDESABTECLATAA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDDESABTECLATAA ' || ' ' || NVL(:NEW.IDDESABTECLATAA, '');
        END IF; 
        IF NVL(:NEW.NRDIAVALIMPPROD, 'NULL') <> NVL(:OLD.NRDIAVALIMPPROD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIAVALIMPPROD ' || ' ' || NVL(:NEW.NRDIAVALIMPPROD, '');
        END IF; 
        IF NVL(:NEW.IDBLOQMAISABERT, 'NULL') <> NVL(:OLD.IDBLOQMAISABERT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDBLOQMAISABERT ' || ' ' || NVL(:NEW.IDBLOQMAISABERT, '');
        END IF; 
        IF NVL(:NEW.IDIMPRTEF, 'NULL') <> NVL(:OLD.IDIMPRTEF, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPRTEF ' || ' ' || NVL(:NEW.IDIMPRTEF, '');
        END IF; 
        IF NVL(:NEW.HRULTENVEMAIL, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.HRULTENVEMAIL, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRULTENVEMAIL ' || ' ' || NVL(:NEW.HRULTENVEMAIL, '');
        END IF; 
        IF NVL(:NEW.IDPEREDTCONSFCXA, 'NULL') <> NVL(:OLD.IDPEREDTCONSFCXA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPEREDTCONSFCXA ' || ' ' || NVL(:NEW.IDPEREDTCONSFCXA, '');
        END IF; 
        IF NVL(:NEW.HRTEMPOROD, 'NULL') <> NVL(:OLD.HRTEMPOROD, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'HRTEMPOROD ' || ' ' || NVL(:NEW.HRTEMPOROD, '');
        END IF; 
        IF NVL(:NEW.VRCONVPONTO, 99999) <> NVL(:OLD.VRCONVPONTO, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRCONVPONTO ' || ' ' || NVL(:NEW.VRCONVPONTO, '');
        END IF; 
        IF NVL(:NEW.IDZEROESQPESQCONS, 'NULL') <> NVL(:OLD.IDZEROESQPESQCONS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDZEROESQPESQCONS ' || ' ' || NVL(:NEW.IDZEROESQPESQCONS, '');
        END IF; 
        IF NVL(:NEW.IDPREVDSALDO, 'NULL') <> NVL(:OLD.IDPREVDSALDO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPREVDSALDO ' || ' ' || NVL(:NEW.IDPREVDSALDO, '');
        END IF; 
        IF NVL(:NEW.CDCAIXANOCASH, 'NULL') <> NVL(:OLD.CDCAIXANOCASH, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDCAIXANOCASH ' || ' ' || NVL(:NEW.CDCAIXANOCASH, '');
        END IF; 
        IF NVL(:NEW.IDCONSDESCTXSERV, 'NULL') <> NVL(:OLD.IDCONSDESCTXSERV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSDESCTXSERV ' || ' ' || NVL(:NEW.IDCONSDESCTXSERV, '');
        END IF; 
        IF NVL(:NEW.NRCREDENTEK, 'NULL') <> NVL(:OLD.NRCREDENTEK, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NRCREDENTEK ' || ' ' || NVL(:NEW.NRCREDENTEK, '');
        END IF; 
        IF NVL(:NEW.DSLOGINAME, 'NULL') <> NVL(:OLD.DSLOGINAME, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSLOGINAME ' || ' ' || NVL(:NEW.DSLOGINAME, '');
        END IF; 
        IF NVL(:NEW.DSLOGINAMEHOM, 'NULL') <> NVL(:OLD.DSLOGINAMEHOM, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSLOGINAMEHOM ' || ' ' || NVL(:NEW.DSLOGINAMEHOM, '');
        END IF; 
        IF NVL(:NEW.DSSENHAAME, 'NULL') <> NVL(:OLD.DSSENHAAME, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSSENHAAME ' || ' ' || NVL(:NEW.DSSENHAAME, '');
        END IF; 
        IF NVL(:NEW.DSSENHAAMEHOM, 'NULL') <> NVL(:OLD.DSSENHAAMEHOM, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSSENHAAMEHOM ' || ' ' || NVL(:NEW.DSSENHAAMEHOM, '');
        END IF; 
        IF NVL(:NEW.IDAMBIENTEAME, 'NULL') <> NVL(:OLD.IDAMBIENTEAME, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAMBIENTEAME ' || ' ' || NVL(:NEW.IDAMBIENTEAME, '');
        END IF; 
        IF NVL(:NEW.VRCASHBACK, 99999) <> NVL(:OLD.VRCASHBACK, 99999) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'VRCASHBACK ' || ' ' || NVL(:NEW.VRCASHBACK, '');
        END IF; 
        IF NVL(:NEW.DSURLSERVAME, 'NULL') <> NVL(:OLD.DSURLSERVAME, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSURLSERVAME ' || ' ' || NVL(:NEW.DSURLSERVAME, '');
        END IF; 
        IF NVL(:NEW.IDTRANSAUTOFISCO, 'NULL') <> NVL(:OLD.IDTRANSAUTOFISCO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDTRANSAUTOFISCO ' || ' ' || NVL(:NEW.IDTRANSAUTOFISCO, '');
        END IF; 
        IF NVL(:NEW.IDUTLINTFACELE, 'NULL') <> NVL(:OLD.IDUTLINTFACELE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTLINTFACELE ' || ' ' || NVL(:NEW.IDUTLINTFACELE, '');
        END IF; 
        IF NVL(:NEW.DSURLWSFACELE, 'NULL') <> NVL(:OLD.DSURLWSFACELE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSURLWSFACELE ' || ' ' || NVL(:NEW.DSURLWSFACELE, '');
        END IF; 
        IF NVL(:NEW.IDAPLPREDIFCOMB, 'NULL') <> NVL(:OLD.IDAPLPREDIFCOMB, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAPLPREDIFCOMB ' || ' ' || NVL(:NEW.IDAPLPREDIFCOMB, '');
        END IF; 
        IF NVL(:NEW.IDEXIBEPRECZERO, 'NULL') <> NVL(:OLD.IDEXIBEPRECZERO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDEXIBEPRECZERO ' || ' ' || NVL(:NEW.IDEXIBEPRECZERO, '');
        END IF; 
        IF NVL(:NEW.APPMENUCONFTE, 'NULL') <> NVL(:OLD.APPMENUCONFTE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'APPMENUCONFTE ' || ' ' || NVL(:NEW.APPMENUCONFTE, '');
        END IF; 
        IF NVL(:NEW.IDSOLCPFDLVRJ, 'NULL') <> NVL(:OLD.IDSOLCPFDLVRJ, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDSOLCPFDLVRJ ' || ' ' || NVL(:NEW.IDSOLCPFDLVRJ, '');
        END IF; 
        IF NVL(:NEW.IDAGRUPITEMXML, 'NULL') <> NVL(:OLD.IDAGRUPITEMXML, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAGRUPITEMXML ' || ' ' || NVL(:NEW.IDAGRUPITEMXML, '');
        END IF; 
        IF NVL(:NEW.NMINSTNOCASH, 'NULL') <> NVL(:OLD.NMINSTNOCASH, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NMINSTNOCASH ' || ' ' || NVL(:NEW.NMINSTNOCASH, '');
        END IF; 
        IF NVL(:NEW.IDIMPRSUBSREST, 'NULL') <> NVL(:OLD.IDIMPRSUBSREST, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPRSUBSREST ' || ' ' || NVL(:NEW.IDIMPRSUBSREST, '');
        END IF; 
        IF NVL(:NEW.IDIMPRVRTOTSUBS, 'NULL') <> NVL(:OLD.IDIMPRVRTOTSUBS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPRVRTOTSUBS ' || ' ' || NVL(:NEW.IDIMPRVRTOTSUBS, '');
        END IF; 
        IF NVL(:NEW.IDPERVENDCONTSP, 'NULL') <> NVL(:OLD.IDPERVENDCONTSP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERVENDCONTSP ' || ' ' || NVL(:NEW.IDPERVENDCONTSP, '');
        END IF; 
        IF NVL(:NEW.IDUTILFID4ALL, 'NULL') <> NVL(:OLD.IDUTILFID4ALL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILFID4ALL ' || ' ' || NVL(:NEW.IDUTILFID4ALL, '');
        END IF; 
        IF NVL(:NEW.CDURLWSFID4ALL, 'NULL') <> NVL(:OLD.CDURLWSFID4ALL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDURLWSFID4ALL ' || ' ' || NVL(:NEW.CDURLWSFID4ALL, '');
        END IF; 
        IF NVL(:NEW.DTVALCERTDIGNFCE, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.DTVALCERTDIGNFCE, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTVALCERTDIGNFCE ' || ' ' || NVL(:NEW.DTVALCERTDIGNFCE, '');
        END IF; 
        IF NVL(:NEW.DTNFCEPEDREJ, TO_DATE('01/01/0001', 'DD/MM/YYYY')) <> NVL(:OLD.DTNFCEPEDREJ, TO_DATE('01/01/0001', 'DD/MM/YYYY')) THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DTNFCEPEDREJ ' || ' ' || NVL(:NEW.DTNFCEPEDREJ, '');
        END IF; 
        IF NVL(:NEW.DSACCESSTOKENMP, 'NULL') <> NVL(:OLD.DSACCESSTOKENMP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSACCESSTOKENMP ' || ' ' || NVL(:NEW.DSACCESSTOKENMP, '');
        END IF; 
        IF NVL(:NEW.DSUSERIDMP, 'NULL') <> NVL(:OLD.DSUSERIDMP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSUSERIDMP ' || ' ' || NVL(:NEW.DSUSERIDMP, '');
        END IF; 
        IF NVL(:NEW.DSIDSPONSORMP, 'NULL') <> NVL(:OLD.DSIDSPONSORMP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSIDSPONSORMP ' || ' ' || NVL(:NEW.DSIDSPONSORMP, '');
        END IF; 
        IF NVL(:NEW.IDAPROVVENDIA, 'NULL') <> NVL(:OLD.IDAPROVVENDIA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAPROVVENDIA ' || ' ' || NVL(:NEW.IDAPROVVENDIA, '');
        END IF; 
        IF NVL(:NEW.IDCONSCREDPESSANGRIA, 'NULL') <> NVL(:OLD.IDCONSCREDPESSANGRIA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSCREDPESSANGRIA ' || ' ' || NVL(:NEW.IDCONSCREDPESSANGRIA, '');
        END IF; 
        IF NVL(:NEW.IDNOTATECNFCE, 'NULL') <> NVL(:OLD.IDNOTATECNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDNOTATECNFCE ' || ' ' || NVL(:NEW.IDNOTATECNFCE, '');
        END IF; 
        IF NVL(:NEW.DSURLNOTIFICMP, 'NULL') <> NVL(:OLD.DSURLNOTIFICMP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'DSURLNOTIFICMP ' || ' ' || NVL(:NEW.DSURLNOTIFICMP, '');
        END IF; 
        IF NVL(:NEW.IDMSGNOTAPEN, 'NULL') <> NVL(:OLD.IDMSGNOTAPEN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDMSGNOTAPEN ' || ' ' || NVL(:NEW.IDMSGNOTAPEN, '');
        END IF; 
        IF NVL(:NEW.IDAPURELRETESTQ, 'NULL') <> NVL(:OLD.IDAPURELRETESTQ, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAPURELRETESTQ ' || ' ' || NVL(:NEW.IDAPURELRETESTQ, '');
        END IF; 
        IF NVL(:NEW.IDEXIBMSGREJNFCE, 'NULL') <> NVL(:OLD.IDEXIBMSGREJNFCE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDEXIBMSGREJNFCE ' || ' ' || NVL(:NEW.IDEXIBMSGREJNFCE, '');
        END IF; 
        IF NVL(:NEW.IDUTICONSONLINE, 'NULL') <> NVL(:OLD.IDUTICONSONLINE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTICONSONLINE ' || ' ' || NVL(:NEW.IDUTICONSONLINE, '');
        END IF; 
        IF NVL(:NEW.CDURLCONSONLINE, 'NULL') <> NVL(:OLD.CDURLCONSONLINE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDURLCONSONLINE ' || ' ' || NVL(:NEW.CDURLCONSONLINE, '');
        END IF; 
        IF NVL(:NEW.IDSINCFILIALDLV, 'NULL') <> NVL(:OLD.IDSINCFILIALDLV, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDSINCFILIALDLV ' || ' ' || NVL(:NEW.IDSINCFILIALDLV, '');
        END IF; 
        IF NVL(:NEW.IDSALDEXTDEBCON, 'NULL') <> NVL(:OLD.IDSALDEXTDEBCON, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDSALDEXTDEBCON ' || ' ' || NVL(:NEW.IDSALDEXTDEBCON, '');
        END IF; 
        IF NVL(:NEW.IDIMPCOMPACTA, 'NULL') <> NVL(:OLD.IDIMPCOMPACTA, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPCOMPACTA ' || ' ' || NVL(:NEW.IDIMPCOMPACTA, '');
        END IF; 
        IF NVL(:NEW.IDWIBXENTERP, 'NULL') <> NVL(:OLD.IDWIBXENTERP, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDWIBXENTERP ' || ' ' || NVL(:NEW.IDWIBXENTERP, '');
        END IF; 
        IF NVL(:NEW.IDWIBXTOKEN, 'NULL') <> NVL(:OLD.IDWIBXTOKEN, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDWIBXTOKEN ' || ' ' || NVL(:NEW.IDWIBXTOKEN, '');
        END IF; 
        IF NVL(:NEW.IDWIBXSELLER, 'NULL') <> NVL(:OLD.IDWIBXSELLER, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDWIBXSELLER ' || ' ' || NVL(:NEW.IDWIBXSELLER, '');
        END IF; 
        IF NVL(:NEW.IDUTLWIBX, 'NULL') <> NVL(:OLD.IDUTLWIBX, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTLWIBX ' || ' ' || NVL(:NEW.IDUTLWIBX, '');
        END IF; 
        IF NVL(:NEW.IDEXIBESTATIS, 'NULL') <> NVL(:OLD.IDEXIBESTATIS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDEXIBESTATIS ' || ' ' || NVL(:NEW.IDEXIBESTATIS, '');
        END IF; 
        IF NVL(:NEW.IDBXULTMOVICLIE, 'NULL') <> NVL(:OLD.IDBXULTMOVICLIE, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDBXULTMOVICLIE ' || ' ' || NVL(:NEW.IDBXULTMOVICLIE, '');
        END IF; 
        IF NVL(:NEW.IDIMPQTCOMBO, 'NULL') <> NVL(:OLD.IDIMPQTCOMBO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPQTCOMBO ' || ' ' || NVL(:NEW.IDIMPQTCOMBO, '');
        END IF; 
        IF NVL(:NEW.IDLIMPMESAPOS, 'NULL') <> NVL(:OLD.IDLIMPMESAPOS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDLIMPMESAPOS ' || ' ' || NVL(:NEW.IDLIMPMESAPOS, '');
        END IF; 
        IF NVL(:NEW.CDURLLIMPMESAPOS, 'NULL') <> NVL(:OLD.CDURLLIMPMESAPOS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDURLLIMPMESAPOS ' || ' ' || NVL(:NEW.CDURLLIMPMESAPOS, '');
        END IF; 
        IF NVL(:NEW.CDAPIKEYLIMPMES, 'NULL') <> NVL(:OLD.CDAPIKEYLIMPMES, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDAPIKEYLIMPMES ' || ' ' || NVL(:NEW.CDAPIKEYLIMPMES, '');
        END IF; 
        IF NVL(:NEW.IDUTILFIDUDS, 'NULL') <> NVL(:OLD.IDUTILFIDUDS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILFIDUDS ' || ' ' || NVL(:NEW.IDUTILFIDUDS, '');
        END IF; 
        IF NVL(:NEW.CDURLWSFIDUDS, 'NULL') <> NVL(:OLD.CDURLWSFIDUDS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDURLWSFIDUDS ' || ' ' || NVL(:NEW.CDURLWSFIDUDS, '');
        END IF; 
        IF NVL(:NEW.IDAJUPICOFSPED, 'NULL') <> NVL(:OLD.IDAJUPICOFSPED, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDAJUPICOFSPED ' || ' ' || NVL(:NEW.IDAJUPICOFSPED, '');
        END IF; 
        IF NVL(:NEW.CONSOIMPAJUS, 'NULL') <> NVL(:OLD.CONSOIMPAJUS, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CONSOIMPAJUS ' || ' ' || NVL(:NEW.CONSOIMPAJUS, '');
        END IF; 
        IF NVL(:NEW.IDFECHRECAUT, 'NULL') <> NVL(:OLD.IDFECHRECAUT, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDFECHRECAUT ' || ' ' || NVL(:NEW.IDFECHRECAUT, '');
        END IF; 
        IF NVL(:NEW.IDUTILINTEPROMO, 'NULL') <> NVL(:OLD.IDUTILINTEPROMO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILINTEPROMO ' || ' ' || NVL(:NEW.IDUTILINTEPROMO, '');
        END IF; 
        IF NVL(:NEW.CDURLINTEPROMO, 'NULL') <> NVL(:OLD.CDURLINTEPROMO, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'CDURLINTEPROMO ' || ' ' || NVL(:NEW.CDURLINTEPROMO, '');
        END IF; 
        IF NVL(:NEW.IDINTEGCATSOLID, 'NULL') <> NVL(:OLD.IDINTEGCATSOLID, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDINTEGCATSOLID ' || ' ' || NVL(:NEW.IDINTEGCATSOLID, '');
        END IF; 
        IF NVL(:NEW.NMSQLSCHEMADB, 'NULL') <> NVL(:OLD.NMSQLSCHEMADB, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NMSQLSCHEMADB ' || ' ' || NVL(:NEW.NMSQLSCHEMADB, '');
        END IF; 
        IF NVL(:NEW.IDDEBCONSCENTRAL, 'NULL') <> NVL(:OLD.IDDEBCONSCENTRAL, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'IDDEBCONSCENTRAL ' || ' ' || NVL(:NEW.IDDEBCONSCENTRAL, '');
        END IF; 
        IF NVL(:NEW.NMSQLNAMEDB, 'NULL') <> NVL(:OLD.NMSQLNAMEDB, 'NULL') THEN
             V_DESC := NVL(V_DESC, '') || ' ' || 'NMSQLNAMEDB ' || ' ' || NVL(:NEW.NMSQLNAMEDB, '');
        END IF; 
        V_ITPESQ := :NEW.CDFILIAL||:NEW.CDPARAVEND;
       V_IDTIPOOPER := '2'; 
    END IF;

   V_DESC := SUBSTR(V_DESC, 1, 4000); 
    INSERT INTO LOGOPERAVND 
       (NMTABELAVND, 
        DTOPERACAOVND, 
        NMRESPOPERVND, 
        IDTIPOOPERVND, 
        DSOPERACAOVND, 
        CDPESQITEMVND, 
        DSRDMUSUOPERVND, 
        DSENDUSUOPERVND, 
        DSNMUSUOPERVND, 
        DSMETUSUOPERVND, 
        CDORESPOPERVND, 
        CDFILLOGOPERVND) 
    VALUES 
       ('PARAVEND', 
        SYSDATE, 
        NVL(V_NMOPERADOR,' '), 
        V_IDTIPOOPER, 
        NVL(V_DESC,' '), 
        V_ITPESQ, 
        V_DSSERVERRDM, 
        V_DSREMOTEADDR, 
        V_DSREMOTEHOST, 
        V_DSSERVMETHOD, 
        V_DSREMOTEOPER, 
        NVL(:NEW.CDFILIAL,:OLD.CDFILIAL));
END; 
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_PARAVEND','6.45.042'); END;
/
