/* Sistemas Integrados TECNISA

Nome: 00NI_CDPTRGS_DTULTATU_DIASPRODUCAO.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela DIASPRODUCAO

Criao:
07/05/2007 Ronald Reis
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_DIASPRODUCAO' and
            type = 'TR'                    and
            u.uid = o.uid                  and
            u.name = USER)
  DROP TRIGGER DTULTATU_DIASPRODUCAO
  GO

CREATE TRIGGER DTULTATU_DIASPRODUCAO
ON DIASPRODUCAO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'DIASPRODUCAO', '', 'CDPERIPRODU=' + CDPERIPRODU+'; DIPRODUCAO=' + DIPRODUCAO +';' , GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE DIASPRODUCAO
      SET DTULTATUDIPR = GETDATE()
      FROM INSERTED
      WHERE ISNULL(DIASPRODUCAO.CDPERIPRODU,0) = ISNULL(INSERTED.CDPERIPRODU,0) AND
            ISNULL(DIASPRODUCAO.DIPRODUCAO,0) = ISNULL(INSERTED.DIPRODUCAO,0)
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_DIASPRODUCAO','4.11.134';
GO
