function ZmartRouteSubscriber(eventAggregator, ViewService, ChartViewController, GenericDashboardController, localStorageEngine) {

    _buildIndicatorView = Util.buildDebounceMethod(function() {
    	ChartViewController.returnBuild();
    }, 1000);

    _buildIndicatorViewPreview = Util.buildDebounceMethod(function() {
    	ChartViewController.returnBuildPreview();
    }, 2000);
    
	eventAggregator.subscribe(EventAggregator.ON_CONTAINER_OPEN, function (openEvent) {
	    if(localStorageEngine.getLocalVar('isLogged')){
            if (openEvent.container) {
                var isDashboard = openEvent.container.name === ViewService.DASHBORAD_WINDOW;
                var isChartView = openEvent.container.name === ViewService.INDICATOR_VIEW_WINDOW;
                var isPreview = openEvent.container.preview;
                if(isDashboard){
                    GenericDashboardController.activateFirstOrLast();   
                } else if(isPreview){
                    _buildIndicatorViewPreview();
                } else if(isChartView){
                    _buildIndicatorView();
                }
            }
	    }
    });
}

Configuration(function(ContextRegister) {
	ContextRegister.register("ZmartRouteSubscriber", ZmartRouteSubscriber);
});