zh-crosstab
====
**zh-crosstab** is a component display data transforming rows into columns.

## Installation
**1)** First of all, check if you have Private Bower's Registry registered in your **.bowerrc** file.
```
{
    "registry": {
        "search": [
            "http://192.168.122.56:5678/"
        ]
    }
}
```


**2)** Then install via Bower:
```
$ bower install --save zh-crosstab
```


**3)** After installed, you need to link the main component's JavaScript file in your **index.html**:
```
<script src="path_to_bower_components/zh-crosstab/dist/zh-crosstab.js">
```
Or the minified version:
```
<script src="path_to_bower_components/zh-crosstab/dist/zh-crosstab.min.js">
```
Do the same with component's CSS file:
```
<link rel="stylesheet" href="path_to_bower_components/zh-crosstab/dist/zh-crosstab.css"/>
```


**4)** **zh-crosstab** already registers itself as a package. The default `baseUrl` registered is:
```
<script type="text/javascript">
    window.templateUrls = [
        {
            package: "zh-crosstab",
            baseUrl: "bower_components/zh-crosstab/dist/templates/"
        }
    ]
</script>
```

So, it considers you have `bower_components` folder in the same path that your `index.html`.

If your `bower_components` is in another folder, you can register your own package path, overwriting the default's one:

```
<script type="text/javascript">
    window.templateUrls = [
        {
            package: "zh-crosstab",
            baseUrl: "path_to_bower_components/zh-crosstab/dist/templates/"
        }
    ]
</script>
```

Be careful: if you already have a `window.templateUrls` registered, just insert the package's information inside of that. **Do not** override with another instance of `window.templateUrls`.

## Using as a Widget in your project
After installed, the component can normally be used in a JSON file:
```
"widgets": [
    {
        "label": "Crosstab data"
        "name": "CROSSTAB_DATA",
        "template": "zh-crosstab#widget/crosstab.html"
    }
]
```
*Remember: zh-crosstab is the package's name registered in your **index.html** using `window.templateUrls`*

## Properties

### hasHtmlContent
This property must be used when is needed to display data inside the grid cells as HTML.
```
"widgets": [
    {
        "name": "crosstab",
        "label": "Crosstab",
        "isVisible": true,
        "template": "zh-crosstab#widget/crosstab.html",
        "hasHtmlContent": true
    }
]
```

## Events
