
// FILE: src/config/config.js
window.templateUrls = window.templateUrls || [];
var packageName = 'zh-crosstab';

var hasPackageRegistered = window.templateUrls.some(function(templateUrl){
	return templateUrl.package === packageName;
});

if(!hasPackageRegistered){
	window.templateUrls.push({
		'package': packageName,
		'baseUrl': './bower_components/' + packageName + '/dist/templates/'
	});
}

// FILE: src/directives/ZhCrosstabDirective.js
(function () {
	var ZeedhiDirectives = angular.module('ZeedhiDirectives');
	ZeedhiDirectives.directive('zhCrosstab', zhCrosstab);

	function zhCrosstab(templateManager, ZHPromise, $timeout) {

		var linkFunction = function (scope, element, attrs) {
			function resizeCrosstabRows() {
				var rowHeight;

				element.find(".body-content .tr").each(function(index, tr) {
					tr = $(tr);
					rowHeight = 0;
					tr.find(".td").each(function(index, td) {
						rowHeight = Math.max(rowHeight, $(td).height());
					});

					tr.height(rowHeight);
					tr.find(".td").height(rowHeight);
				});

				scope.resizeGridColumns();
			}

			scope.resizeCrosstabContent = function() {
				if (scope.widget.htmlContent) {
					$timeout(resizeCrosstabRows, 0);
				} else {
					scope.resizeGridColumns();					
				}
			};
		};

		return {
			restrict: 'A',
			link: linkFunction
		};
	}
})();