## ZH DESCRIPTION

ZhDescription is a component that allows to maintain a static text on the screen.

To start using the component you must follow the steps bellow:

 - Add on your project bower.json file the dependency:

 ```javascript
 "zh-description": "LASTEST_STABLE_VERSION"
 ```

 Today the LASTEST_STABLE_VERSION is 0.1.

 - Run `bower install`

 - Then add its script within your project index:
 ```html
<!-- Zh-Description -->
<script src="BOWER_COMPONENTS_PATH/zh-description/dist/zh-description.js"></script>
 ```

 - Or the minified version:
 ```html
<!-- Zh-Select-Autocomplete -->
<script src="BOWER_COMPONENTS_PATH/zh-description/dist/zh-description.min.js"></script>
 ```

 - Add the stylesheet:
 ```html
<link rel="stylesheet" href="BOWER_COMPONENTS_PATH/zh-description/src/styles/zh-description.css" />
```
 - And then you add the template package within your config.js:
 ```javascript
 {
        package: 'zh-select-autocomplete',
        baseUrl: 'MY_BOWER_COMPONENTS_PATH/zh-description/dist/templates/'
 }
 ```

## Using the component

 Like any field, zh-description needs a name and a template, and also an automatically generated id. Its differeces are that zh-description:

  - Use 'head' instead 'label'.
  - Has a property called 'body', that is the main text.

```javascript
 {
	"id": "35456546",
	"name": "componentPresentation",
	"template": "zh-description#field/description.html",
	"head": "This is an simple example, with only the necessary configuration",
	"body": "This component provides the feature of insert a static text on the screen."
 }