
// FILE: example/frontend/js/SelectAutocompleteController.js
function SelectAutocompleteController(ScreenService, templateManager) {

	this.edit = function(widget) {
        widget.edit();
        widget.template = widget.templateToForm;
    };

    this.view = function(widget) {
        widget.view();
        widget.template = widget.templateToView;
    };

    this.cancel = function(widget) {
        widget.view();
        widget.template = widget.templateToView;
        widget.currentRow = {};
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SelectAutocompleteController', SelectAutocompleteController);
});

// FILE: example/frontend/js/SelectAutocompleteEvents.js
function SelectAutocompleteEvents(ScreenService, templateManager, metaDataFactory) {

    var onChange = {
        oldValue: "",
        newValue: ""
    };

	this.onChange = function(args) {
        onChange.oldValue = onChange.newValue;
        onChange.newValue = args.EMPLOYEE_ID;
        ScreenService.successNotification(
            "Value changed!"
            + (onChange.oldValue ? (" Old value: " + onChange.oldValue) : (""))
            + (onChange.newValue ? (" New value: " + onChange.newValue) : ("")));

    };

    this.onInput = function(args) {
        ScreenService.successNotification("Field input!");
    };

    this.onClick = function(args) {
        ScreenService.successNotification("Field Clicked!");
    };

    this.onBlur = function(args) {
        ScreenService.showMessage("Field Obfuscated!");
    };

    this.onKeypress = function(args) {
        var keyPressed = args.e.key;
        ScreenService.successNotification("Key Pressed: " + keyPressed);
    };

    this.onKeyup = function(args) {
        var keyReleased = args.e.key;
        ScreenService.successNotification("Key Released: " + keyReleased);
    };

    this.onKeydown = function(args) {
        var keyPressed = args.e.key;
        ScreenService.successNotification("Key Pressed: " + keyPressed);
    };

    this.beforeSelectOpen = function(args) {
        ScreenService.showMessage("Right before open popup!");
    };

    this.afterSelectOpen = function(args) {
        ScreenService.showMessage("Right after open popup!");
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SelectAutocompleteEvents', SelectAutocompleteEvents);
});

// FILE: example/frontend/js/SelectAutocompleteValidations.js
function SelectAutocompleteValidations(ScreenService, templateManager) {

    this.isValid = function(widget){
        var str = "";
        if(widget.isValid()){
            str = "Field is valid!";
        }
        else{
            str = "Field is not valid!"
        }

        ScreenService.successNotification(str);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('SelectAutocompleteValidations', SelectAutocompleteValidations);
});

// FILE: example/frontend/js/SelectAutocompleteValidators.js
function SelectAutocompleteValidators(ScreenService, templateManager) {

    this.employee_idValidator = function(value){
        return true;
    };

    this.job_titleValidator = function(value){
        return true;
    };

    this.first_nameValidator = function(value){
        return false;
    }

    this.hire_dateValidator = function(value){
        return true;
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('SelectAutocompleteValidators', SelectAutocompleteValidators);
});