function SelectAutocompleteEvents(ScreenService, templateManager, metaDataFactory) {

    var onChange = {
        oldValue: "",
        newValue: ""
    };

	this.onChange = function(args) {
        onChange.oldValue = onChange.newValue;
        onChange.newValue = args.EMPLOYEE_ID;
        ScreenService.successNotification(
            "Value changed!"
            + (onChange.oldValue ? (" Old value: " + onChange.oldValue) : (""))
            + (onChange.newValue ? (" New value: " + onChange.newValue) : ("")));

    };

    this.onInput = function(args) {
        ScreenService.successNotification("Field input!");
    };

    this.onClick = function(args) {
        ScreenService.successNotification("Field Clicked!");
    };

    this.onBlur = function(args) {
        ScreenService.showMessage("Field Obfuscated!");
    };

    this.onKeypress = function(args) {
        var keyPressed = args.e.key;
        ScreenService.successNotification("Key Pressed: " + keyPressed);
    };

    this.onKeyup = function(args) {
        var keyReleased = args.e.key;
        ScreenService.successNotification("Key Released: " + keyReleased);
    };

    this.onKeydown = function(args) {
        var keyPressed = args.e.key;
        ScreenService.successNotification("Key Pressed: " + keyPressed);
    };

    this.beforeSelectOpen = function(args) {
        ScreenService.showMessage("Right before open popup!");
    };

    this.afterSelectOpen = function(args) {
        ScreenService.showMessage("Right after open popup!");
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SelectAutocompleteEvents', SelectAutocompleteEvents);
});