/**
 * Controller
 **/
function ZmartAccordionController($scope, maskEngine, ZhUtil, ScreenService, ApplicationContext, templateManager){
    var self = this;
    var widget = $scope.widget;

    self.hasIndicators = function(item) {
        return item.dataSource && item.dataSource.data && item.dataSource.data.length > 0;
    };
    
    DrillDownController = ApplicationContext.DrillDownController;
    self.itemClick = function(widget) {
        DrillDownController.openNextIndicatorView(widget,{});
    };
    
    GenericDashboardFactory = ApplicationContext.GenericDashboardFactory;
    self.factoryDashboardAccordionActions = function(item, container){
        GenericDashboardFactory.factoryDashboardAccordionActions(item, container);
    };

    GenericDashboardService = ApplicationContext.GenericDashboardService;
    self.addDataAccordionWidget = function(item){
        GenericDashboardService.addDataAccordionWidget(item);
    };

    self.selectedItem = undefined;
    self.toggleItem = function(item) {
        var container = templateManager.container;
		var currentWidget = container.getActiveWidget();
		if(currentWidget.label !== "Dashboard" && item.label !== currentWidget.label){
            currentWidget.opened = false;
            currentWidget.calcElementHeight();
		}
		
        item.opened = !item.opened;
        item.activate();
        if (item.opened && widget.exclusive) {
            if (self.selectedItem && self.selectedItem != item) {
                self.selectedItem.opened = false;
                self.selectedItem.calcElementHeight();
            }
            self.selectedItem = item;
        }
        self.factoryDashboardAccordionActions(item, container);
        self.addDataAccordionWidget(item);
        item.calcElementHeight();
    };
    
    self.applyMask = function(cardMask, value) {
        var mask = {};
        mask.type = cardMask;
        return Util.applyMask(value, mask, maskEngine, ZhUtil);
    };

    self.getGradientCSS = function(gradient) {
        var css = "";
        if (gradient) {
            gradient = Util.parseToArray(gradient);
            if (gradient.length === 1)     {
                css = "background: "+gradient[0]+";";
            } else {
                css = "background: "+gradient[0]+"; background: -webkit-linear-gradient(left, "+gradient[0]+" 0%,"+gradient[1]+" 100%); background: linear-gradient(to right, "+gradient[0]+" 0%,"+gradient[1]+" 100%);";
            }
        }
        return css;
    };
}