CREATE TABLE ESO_EVENTO (
  NREVENTO NUMBER(10) NOT NULL, 
  DSEVENTO VARCHAR2(4000) DEFAULT NULL NULL, 
  NMEVENTO VARCHAR2(10) DEFAULT NULL NULL, 
  IDGRUPO VARCHAR2(1) DEFAULT NULL NULL, 
  DSVERSAO VARCHAR2(10) NOT NULL, 
  NRORG NUMBER(10) DEFAULT 1 NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT 1 NULL, 
  NRORGULTATU NUMBER(10) DEFAULT 1 NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NULL,
  CONSTRAINT PK_ESO_EVENTO PRIMARY KEY(NRORG, NREVENTO)
)
/
ALTER TABLE ESO_EVENTO ADD CONSTRAINT CKC_GRUPO_ESO_EVENTO CHECK (IDGRUPO IN ('I','T','P','N'))
/
ALTER TABLE ESO_EVENTO ADD CONSTRAINT CKC_IDATIVO_ESO_EVENTO CHECK (IDATIVO IN ('S','N'))
/
CREATE TABLE ESO_RESUMO (
  NRRESUMO NUMBER(10) NOT NULL, 
  NREVENTO NUMBER(10) DEFAULT NULL NULL, 
  NMREGISTRO VARCHAR2(40) DEFAULT NULL NULL, 
  NMREGISROPAI VARCHAR2(40) DEFAULT NULL NULL, 
  NRNIVEL NUMBER(10) DEFAULT NULL NULL, 
  DSRESUMO VARCHAR2(1000) DEFAULT NULL NULL, 
  DSOCORRENCIA VARCHAR2(10) DEFAULT NULL NULL, 
  DSCHAVE VARCHAR2(100) DEFAULT NULL NULL, 
  DSCONDICAO VARCHAR2(1000) DEFAULT NULL NULL, 
  NRORG NUMBER(10) DEFAULT 1 NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT 1 NULL, 
  NRORGULTATU NUMBER(10) DEFAULT 1 NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL,
  CONSTRAINT PK_ESO_RESUMO PRIMARY KEY(NRORG, NRRESUMO)
)
/
ALTER TABLE ESO_RESUMO ADD CONSTRAINT CKC_IDATIVO_ESO_RESUMO CHECK (IDATIVO IN ('S','N'))
/
CREATE TABLE ESO_REGISTRO (
  NRREGISTRO NUMBER(10) NOT NULL, 
  NREVENTO NUMBER(10) DEFAULT NULL NULL, 
  NRCAMPO NUMBER(10) DEFAULT NULL NULL, 
  NMCAMPO VARCHAR2(40) DEFAULT NULL NULL, 
  NRCAMPOPAI NUMBER(10) DEFAULT NULL NULL, 
  NMCAMPOPAI VARCHAR2(40) DEFAULT NULL NULL, 
  DSELEMENTO VARCHAR2(1) DEFAULT NULL NULL, 
  DSTIPO VARCHAR2(1) DEFAULT NULL NULL, 
  DSOCORRENCIA VARCHAR2(10) DEFAULT NULL NULL, 
  NRTAMANHO NUMBER(10) DEFAULT NULL NULL, 
  NRDECIMAIS NUMBER(10) DEFAULT NULL NULL, 
  DSREGISTRO VARCHAR2(4000) DEFAULT NULL NULL, 
  NRORG NUMBER(10) DEFAULT 1 NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT 1 NULL, 
  NRORGULTATU NUMBER(10) DEFAULT 1 NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL,
  CONSTRAINT PK_ESO_REGISTRO PRIMARY KEY(NRORG, NRREGISTRO)
)
/
ALTER TABLE ESO_REGISTRO ADD CONSTRAINT FKHCM00005EVENTO FOREIGN KEY (NRORG, NREVENTO) REFERENCES ESO_EVENTO (NRORG, NREVENTO)
/
ALTER TABLE ESO_REGISTRO ADD CONSTRAINT CKC_IDATIVO_ESO_REGISTRO CHECK (IDATIVO IN ('S','N'))
/
ALTER TABLE ESO_RESUMO ADD CONSTRAINT FKHCM00004EVENTO FOREIGN KEY (NRORG, NREVENTO) REFERENCES ESO_EVENTO (NRORG, NREVENTO)
/
CREATE TABLE ESO_ENVIOCADASTROS (
  NRENVIO NUMBER(10) NOT NULL, 
  NREVENTO NUMBER(10) NOT NULL, 
  NRESTRUTURAM NUMBER(10) DEFAULT NULL NULL, 
  NRCHAVE NUMBER(10) DEFAULT NULL NULL, 
  DTMESCOMPETENC DATE DEFAULT NULL NULL, 
  IDEVENTO VARCHAR2(50) DEFAULT NULL NULL, 
  IDOPERACAO VARCHAR2(1) DEFAULT NULL NULL, 
  DTENVIO DATE DEFAULT NULL NULL, 
  DTRESPOSTA DATE DEFAULT NULL NULL, 
  IDSTATUS VARCHAR2(1) DEFAULT NULL NULL, 
  CDERRO VARCHAR2(10) DEFAULT NULL NULL, 
  NRRECIBO VARCHAR2(50) DEFAULT NULL NULL, 
  DSOBSERVACAO VARCHAR2(1000) DEFAULT NULL NULL, 
  DSDIRXMLENV VARCHAR2(100) DEFAULT NULL NULL, 
  DSDIRXMLRETENV VARCHAR2(100) DEFAULT NULL NULL, 
  DSDIRXMLRETPRO VARCHAR2(100) DEFAULT NULL NULL, 
  NRORG NUMBER(10) DEFAULT 1 NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT 1 NULL, 
  NRORGULTATU NUMBER(10) DEFAULT 1 NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL,
  CONSTRAINT PK_ESO_ENVIOCAD PRIMARY KEY(NRORG, NRENVIO)
)