<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class VabIntegtranspm extends \Doctrine\ORM\EntityRepository {

    public function retornaValeTransporte($nrintegtranspm, $nrOrg, $nrOrgPadrao, $dtCompetencia){
	
        $vabIntegtranspm =  'Teknisa\Model\Gestaopessoas\Entities\VabIntegtranspm';
        $vabIntegtransph =  'Teknisa\Model\Gestaopessoas\Entities\VabIntegtransph';
    
        $sql = <<<SQL
    SELECT 
        im, ih
    FROM 
        $vabIntegtranspm im
    INNER JOIN 
        $vabIntegtransph ih 
    WITH 
        im.nrintegtranspm     = ih.nrintegtranspm
        AND ih.dtmescompinteg = ( SELECT 
                                    MAX(ihh.dtmescompinteg) 
                                  FROM 
                                    $vabIntegtransph ihh
                                  WHERE ihh.dtmescompinteg <= :p_dtmescompinteg
                                    AND ihh.nrintegtranspm =  ih.nrintegtranspm 
                                )
    WHERE
        im.nrintegtranspm  = :p_nrintegtranspm
        and (im.nrorg = :p_nrorg or im.nrorg = :p_nrorg_padrao)
        ORDER BY im.nrintegtranspm                                               
SQL;
        $params = array(
            'p_nrorg'           => $nrOrg,
            'p_nrorg_padrao'    => $nrOrgPadrao,
            'p_nrintegtranspm'  => $nrintegtranspm,
            'p_dtmescompinteg' => $dtCompetencia,
        );
        
        $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        $resultado = array();
        
        foreach ($resultQuery as $key => $value) {
            if($value instanceof $vabIntegtranspm){
                $value->historico = $resultQuery[$key+1];
                $resultado[] = $value;
            }    
        }
        return $resultado;
    }    

} 