<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\Repositories;

class GpeOcupacaom extends \Doctrine\ORM\EntityRepository {
    
    public function retornaOcupacao($nrOrg, $nrOcupacao, $mesCompetencia){
	
    $GpeOcupacaom =  'Teknisa\Model\Gestaopessoas\Entities\GpeOcupacaom';
    $GpeOcupacaoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeOcupacaoh';

$sql = <<<SQL
    SELECT pm, ph
    FROM $GpeOcupacaom pm 
    INNER JOIN 
    $GpeOcupacaoh ph WITH 
    ph.dtmescompetenc = (
			SELECT MAX(sub.dtmescompetenc)
  			FROM $GpeOcupacaoh sub
  			WHERE sub.dtmescompetenc <= :p_dtmescompetenc
  			AND ph.nrorg = sub.nrorg
  			AND ph.nrocupacaom = sub.nrocupacaom
  			)
		AND ph.nrorg = pm.nrorg
		AND ph.nrocupacaom = pm.nrocupacaom    
    WHERE 
    pm.nrorg = :p_nrorg AND
    pm.nrocupacaom = :nrocupacaom
SQL;
            $params = array(
                'p_dtmescompetenc' => $mesCompetencia,
                'p_nrorg' => $nrOrg,
                'nrocupacaom' => $nrOcupacao
            );
            
            $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
            $resultado = array();
            foreach ($resultQuery as $key => $ocupacao) {
                if($ocupacao instanceof $GpeOcupacaom){
                    $ocupacao->historico = $resultQuery[$key+1];
                    $resultado[] = $ocupacao;
                }    
            }
            return $resultado[0];
    }
    
}