<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class GpePessoa extends \Doctrine\ORM\EntityRepository {

    public function retornaPessoaAtual($nrOrg, $nrPessoa, $mesCompetencia){
	
        $gpe_pessoa =  'Teknisa\Model\Gestaopessoas\Entities\GpePessoa';
        $gpe_pessoah =  'Teknisa\Model\Gestaopessoas\Entities\GpePessoah';

$sql = <<<SQL
    SELECT pm, ph
    FROM $gpe_pessoa pm 
    INNER JOIN
    $gpe_pessoah ph WITH 
    ph.dtmescompetenc = (
			SELECT MAX(phh.dtmescompetenc)
  			FROM $gpe_pessoah phh
  			WHERE phh.dtmescompetenc <= :p_dtmescompetenc
  			AND ph.nrorg = phh.nrorg
  			AND ph.nrpessoa = phh.nrpessoa
  			)
		AND ph.nrorg = pm.nrorg
		AND ph.nrpessoa = pm.nrpessoa    
    WHERE 
    pm.nrorg = :p_nrorg
    and pm.nrpessoa = :nrpessoa
    
SQL;
            $params = array(
                'p_dtmescompetenc' => $mesCompetencia,
                'p_nrorg' => $nrOrg,
                'nrpessoa' => $nrPessoa
            );
            
            $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $resultado = array();
            foreach ($resultQuery as $key => $pessoa) {
                if($pessoa instanceof $gpe_pessoa){
                    $pessoa->historico = $resultQuery[$key+1];
                    $resultado[] = $pessoa;
                }    
            }
            return $resultado[0];
    }
    
    public function retornaPessoaPorParceiro($nrOrg, $nrParcNegocio, $mesCompetencia){
	
        $gpe_pessoa =  'Teknisa\Model\Gestaopessoas\Entities\GpePessoa';
        $gpe_pessoah =  'Teknisa\Model\Gestaopessoas\Entities\GpePessoah';

$sql = <<<SQL
    SELECT pm, ph
    FROM $gpe_pessoa pm 
    INNER JOIN
    $gpe_pessoah ph WITH 
    ph.dtmescompetenc = (
			SELECT MAX(phh.dtmescompetenc)
  			FROM $gpe_pessoah phh
  			WHERE phh.dtmescompetenc <= :p_dtmescompetenc
  			AND ph.nrorg = phh.nrorg
  			AND ph.nrpessoa = phh.nrpessoa
  			)
		AND ph.nrorg = pm.nrorg
		AND ph.nrpessoa = pm.nrpessoa    
    WHERE 
    pm.nrorg = :p_nrorg
    and pm.nrparcnegocio = :nrparcnegocio
    
SQL;
            $params = array(
                'p_dtmescompetenc' => $mesCompetencia,
                'p_nrorg' => $nrOrg,
                'nrparcnegocio' => $nrParcNegocio
            );
            
            $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $resultado = array();
            foreach ($resultQuery as $key => $pessoa) {
                if($pessoa instanceof $gpe_pessoa){
                    $pessoa->historico = $resultQuery[$key+1];
                    $resultado[] = $pessoa;
                }    
            }
            
            if(isset($resultado[0])) return $resultado[0];
            else return null;
    }
}