<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\Repositories;

class GpeVinculom extends \Doctrine\ORM\EntityRepository {
    
    public function retornaVinculosEstrutLegalDifereMovimentacao($nrorg, $dtmescompetenc, $nrtipotransflegal, $nrtipoestrutlegal, $condIntervalo=null, $condAtivos=null)
    {
	    
	    $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtmescompetenc));
    	$params = array('dtmescompetenc'=>$dtmescompetenc, 'nrorg'=>$nrorg, 'nrtipotransflegal' =>$nrtipotransflegal,
    	'nrtipoestrutlegal' =>$nrtipoestrutlegal, 'dtultdiames' => $dtUltDiaMes);
    	
        $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
        $gpevinculom =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculom';
        $gpeMovimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        $estruturam =  'Teknisa\Model\Geral\Entities\Estruturam';

$sql = <<<SQL
SELECT vm
  FROM $gpevinculom vm, $gpevinculoh vh
 WHERE vm.nrorg = :nrorg
   AND vh.nrorg          = vm.nrorg
   AND vh.nrvinculom     = vm.nrvinculom
   AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                                FROM $gpevinculoh vhh
                               WHERE vhh.nrvinculom      = vh.nrvinculom
                                 AND vhh.nrorg           = vh.nrorg
                                 AND vhh.dtmescompetenc <= :dtmescompetenc
                            )
   AND EXISTS (SELECT 1
                 FROM $gpeMovimentacao mo, $estruturam e
                WHERE e.nrorg                 = mo.nrorg
                  AND e.nrestruturam          = mo.nrestruturam
                  AND e.nrtipoestrutura       = mo.nrtipoestrutura
                  AND mo.nrvinculom      = vh.nrvinculom
                  AND mo.nrorg           = vh.nrorg
                  AND mo.nrtipotransfer  = :nrtipotransflegal
                  AND mo.nrtipoestrutura = :nrtipoestrutlegal
                  AND mo.nrestruturam   <> vh.nrestrutlegal
                  AND mo.dtinimoviment = (SELECT MAX(m.dtinimoviment)
                                            FROM $gpeMovimentacao m
                                            WHERE m.nrvinculom       = vh.nrvinculom
                                             AND m.nrorg            = vh.nrorg
                                             AND m.nrtipotransfer   = :nrtipotransflegal
                                             AND m.nrtipoestrutura  = :nrtipoestrutlegal
                                             AND m.dtinimoviment <= :dtultdiames
                                         )
                  AND (mo.dtfimmoviment >= :dtmescompetenc OR mo.dtfimmoviment IS NULL)
               )
SQL;
        $sql .= ($condIntervalo ? $condIntervalo : "");

        $sql .= ($condAtivos ? $condAtivos : "");
        $vinculos = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return $vinculos;
    }
    
     public function retornaVinculosEstrutGerenDifereMovimentacao($nrorg, $dtmescompetenc, $nrtipotransfgeren, $nrtipoestrutgeren, $condIntervalo=null, $condAtivos=null)
    {
	    $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtmescompetenc));
    	$params = array('dtmescompetenc'=>$dtmescompetenc, 'nrorg'=>$nrorg, 'nrtipotransfgeren' =>$nrtipotransfgeren,
    	'nrtipoestrutgeren' =>$nrtipoestrutgeren, 'dtultdiames' => $dtUltDiaMes);
    	
        $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
        $gpevinculom =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculom';
        $gpeMovimentacao = 'Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        $estruturam =  'Teknisa\Model\Geral\Entities\Estruturam';

$sql = <<<SQL
SELECT vm
  FROM $gpevinculom vm, $gpevinculoh vh
 WHERE vm.nrorg = :nrorg
   AND vh.nrorg          = vm.nrorg
   AND vh.nrvinculom     = vm.nrvinculom
   AND vm.nrtipovinculom <> 10
   AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                                FROM $gpevinculoh vhh
                               WHERE vhh.nrvinculom      = vh.nrvinculom
                                 AND vhh.nrorg           = vh.nrorg
                                 AND vhh.dtmescompetenc <= :dtmescompetenc
                            )
   AND EXISTS (SELECT 1
                 FROM $gpeMovimentacao mo, $estruturam e
                WHERE e.nrorg                 = mo.nrorg
                  AND e.nrestruturam          = mo.nrestruturam
                  AND e.nrtipoestrutura       = mo.nrtipoestrutura
                  AND mo.nrvinculom      = vh.nrvinculom
                  AND mo.nrorg           = vh.nrorg
                  AND mo.nrtipotransfer  = :nrtipotransfgeren
                  AND mo.nrtipoestrutura = :nrtipoestrutgeren
                  AND mo.nrestruturam   <> vh.nrestrutgeren
                  AND mo.dtinimoviment = (SELECT MAX(m.dtinimoviment)
                                            FROM $gpeMovimentacao m
                                            WHERE m.nrvinculom       = vh.nrvinculom
                                             AND m.nrorg            = vh.nrorg
                                             AND m.nrtipotransfer   = :nrtipotransfgeren
                                             AND m.nrtipoestrutura  = :nrtipoestrutgeren
                                             AND m.dtinimoviment <= :dtultdiames
                                         )
               )
SQL;
        $sql .= ($condIntervalo ? $condIntervalo : "");

        $sql .= ($condAtivos ? $condAtivos : "");
        $vinculos = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return $vinculos;
    }
    
    public function retornaVinculosRescisaoComplementar($nrorg, $nrpessoa, $dtmescompetenc, $nrtpmodalidcal, $condIntervalo=null, $condAtivos=null) {
	    $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtmescompetenc));
    	$params = array('nrorg'=>$nrorg, 'nrpessoa' => $nrpessoa, 'dtmescompetenc'=>$dtmescompetenc, 'nrtpmodalidcal'=>$nrtpmodalidcal);
    	
        $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
        $gpevinculom =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculom';
        $fpaCalculofolha = 'Teknisa\Model\Gestaopessoas\Entities\FpaCalculofolha';
        $fpaItecalcfolha =  'Teknisa\Model\Gestaopessoas\Entities\FpaItecalcfolha';

$sql = <<<SQL
SELECT vm
  FROM $gpevinculom vm, $gpevinculoh vh
 WHERE vm.nrorg = :nrorg
   AND vm.nrpessoa = :nrpessoa
   AND vh.nrorg = vm.nrorg
   AND vh.nrvinculom = vm.nrvinculom
   AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                              FROM $gpevinculoh vhh
                             WHERE vhh.nrvinculom = vh.nrvinculom
                               AND vhh.nrorg = vh.nrorg
                               AND vhh.dtmescompetenc <= :dtmescompetenc)
   AND EXISTS (SELECT 1
                 FROM $fpaCalculofolha cf, $fpaItecalcfolha ic
                WHERE ic.nrorg          = vh.nrorg
                  AND ic.nrvinculom     = vh.nrvinculom
                  AND ic.nreventom      = 3050
                  AND cf.nrorg          = ic.nrorg
                  AND cf.nrcalculofolha = ic.nrcalculofolha
                  AND cf.dtocorrencia   = :dtmescompetenc
                  AND cf.nrtipomoviment = 1
                  AND cf.nrtpmodalidcal = :nrtpmodalidcal
               )
SQL;
        $sql .= ($condIntervalo ? $condIntervalo : "");
        $sql .= ($condAtivos ? $condAtivos : "");
        $vinculos = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return $vinculos;
    }
    
    public function retornaVinculos($nrOrg, $mesCompetencia, $condProcesso = null, $condIntervalo = null, $ordenacao = null, $condEstrutura = null, $verificaConfidencial = true, $nrTipoVinculom = null, $nrVinculoEmpreg = null, $nrEstrutSind = null, $params = array(), $isRais = false) {

        $primeiroDiaAno = DateUtil::getPrimeiroDiaDoAno(DateUtil::getDataDeString($mesCompetencia));;
        
        $sqlParams = self::_montaSQLVinculo($nrOrg, $mesCompetencia, $primeiroDiaAno, $condProcesso, $condIntervalo, $ordenacao, $condEstrutura, $verificaConfidencial, $nrTipoVinculom, $nrVinculoEmpreg, $nrEstrutSind, $params, $isRais);
        
        unset($primeiroDiaAno);
        
        return $this->_retornaVinculos($nrOrg, $sqlParams, $mesCompetencia);
    }
    
    private static function _montaSQLVinculo($nrOrg, $mesCompetencia, $primeiroDiaAno, $condProcesso, $condIntervalo, $ordenacao, $condEstrutura,$verificaConfidencial = true, $nrTipoVinculom = null, $nrVinculoEmpreg = null, $nrEstrutSind = null, $params = array(), $isRais = false) {
        
        $processo = false;
        $intervalo = false;
        $estrutura = false;
        $confidencial = '';
        
        $fpaIteCalcFolha = Repositories::FPA_ITECALCFOLHA;
        $fpaCalculoFolha = Repositories::FPA_CALCULOFOLHA;
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        
        $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($mesCompetencia));
        
        if(FPA::getRestConfidencial()==='S' && $verificaConfidencial){
            $confidencial = " AND vh.confidencial='N' ";
        }
        
        if ($isRais) {
            $params['p_primeirodiaano'] = $primeiroDiaAno->format('d/m/Y');
        } else {
            $params['p_primeirodiaano'] = DateUtil::subtraiIntervalo($primeiroDiaAno->format('d/m/Y'), 1, DateUtil::ANO)->format('d/m/Y');
        }
        
        $params['p_nrorg'] = $nrOrg;
        $params['p_dtultdiames'] = $dtUltDiaMes->format('d/m/Y');
        
$sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc BETWEEN :p_primeirodiaano AND :p_dtultdiames
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              $confidencial
SQL;

        $where = ' WHERE ';
        $where .= 'vm.nrorg = :p_nrorg AND ';

        if (empty($condProcesso) === false) {
            $where .= $condProcesso;
            $processo = true;
        }
        if (empty($condIntervalo) === false) {
            if ($processo === true) {
                $where .= ' AND ';
            }

            $where .= $condIntervalo;
            $intervalo = true;
        }
        
        if (empty($condEstrutura) === false) {
            if (($processo === true) || ($intervalo === true)) {
                $where .= ' AND ';
            }

            $where .= $condEstrutura;
            $estrutura = true;
        }

        if ($processo === false
            && $intervalo === false
            && $estrutura === false
        ) {
            $where .= ' (1=1) ';
        }

        if($nrTipoVinculom != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['p_nrtipovinculom'] = $nrTipoVinculom;
            $where .= 'vm.nrtipovinculom = :p_nrtipovinculom';
        }

        if($nrVinculoEmpreg != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['p_nrvinculoempreg'] = $nrVinculoEmpreg;
            $where .= 'vm.nrvinculoempreg = :p_nrvinculoempreg';
        }

        if($nrEstrutSind != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $params['nrestrutsind'] = $nrEstrutSind;
            $where .= 'vh.nrestrutsind = :nrestrutsind';
        }

        if (empty($ordenacao) === false) {
            $where .= ' '.$ordenacao;
        }
        $sql .= $where;
        return array('SQL' => $sql,'PARAMS'=> $params);
    }
    
    public function _retornaVinculos($nrorg, $sqlParams, $mesCompetencia){
        if (is_array($sqlParams)) {
            $resultado = $this->getEntityManager()->createQuery($sqlParams['SQL'])->execute($sqlParams['PARAMS']);
        }
        
        $vinculos = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculos[] = $vinc;
            }    
        }
        
        return $vinculos;
    }
    
    public function retornaVincMestreHistorico($nrOrg, $nrVinculom, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND vm.nrvinculom = :nrvinculom
SQL;
        $params = array('nrorg' => $nrOrg, 'nrvinculom' => $nrVinculom, 'dtmescompetenc' => $dtCompetencia);
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo[0];
    }
    
    public function retornaVinculosEstrutLegal($nrOrg, $nrestrutlegal, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND vh.nrestrutlegal = :nrestrutlegal
SQL;
        $params = array('nrorg' => $nrOrg, 'nrestrutlegal' => $nrestrutlegal, 'dtmescompetenc' => $dtCompetencia);
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo;
    }
    
    public function retornaVinculosEstrutGeren($nrOrg, $nrestrutgeren, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND vh.nrestrutgeren = :nrestrutgeren
SQL;
        $params = array('nrorg' => $nrOrg, 'nrestrutgeren' => $nrestrutgeren, 'dtmescompetenc' => $dtCompetencia);
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo;
    }
    
    public function retornaVinculosEstrutSind($nrOrg, $nrestrutsind, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND vh.nrestrutsind = :nrestrutsind
SQL;
        $params = array('nrorg' => $nrOrg, 'nrestrutsind' => $nrestrutsind, 'dtmescompetenc' => $dtCompetencia);
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo;
    }
    
        public function retornaVinculosAtivos ($nrOrg, $dtCompetencia)
    {
        $gpevinculom =  Repositories::GPE_VINCULOM;
        $gpevinculoh = Repositories::GPE_VINCULOH;
        
        $sql = <<<SQL
    SELECT vm, vh
			  FROM $gpevinculom vm
			  JOIN $gpevinculoh vh WITH
                vh.dtmescompetenc =
                    (SELECT MAX(vhh.dtmescompetenc)
                        FROM $gpevinculoh vhh
                        WHERE vhh.dtmescompetenc <= :dtmescompetenc
                        AND vhh.nrorg = vh.nrorg
                        AND vhh.nrvinculom = vh.nrvinculom
                    )
              AND vh.nrvinculom = vm.nrvinculom
              AND vh.nrorg = vm.nrorg
              WHERE 
              vm.nrorg = :nrorg
              AND ( vm.dtrescisaovinc is null 
              OR vm.dtrescisaovinc >= :dtmescompetenc)
SQL;
        $params = array('nrorg' => $nrOrg, 'dtmescompetenc' => $dtCompetencia);
        
        $resultado = $this->getEntityManager()->createQuery($sql)->execute($params);
            
        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo;
    }
    
    public function _retornaHistórico($nrVinculoM, $nrorg, $dtCompetencia){
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_NRORG'       => $nrorg, 
            'P_NRVINCULOM'  => $nrVinculoM,
            'P_DTMESCOMPETENC'=>$dtCompetencia,
        );

$sql = <<<SQL
    SELECT * FROM GPE_VINCULOH 
    WHERE NRVINCULOM = :P_NRVINCULOM AND NRORG = :P_NRORG 
    AND DTMESCOMPETENC = ( SELECT MAX(AUX.DTMESCOMPETENC) FROM GPE_VINCULOH AUX WHERE AUX.NRORG = GPE_VINCULOH.NRORG AND AUX.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND AUX.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
SQL;
        $result = $db->fetchAll($sql,$params);

        if(isset($result[0])) return $result[0];
        else return null;
    }
    
    public function _retornaAniversariantes(){
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array();

$sql = <<<SQL
      SELECT 
        ORGANIZACAO.NRORG,
        ORGANIZACAO.NMORGANIZACAO, 
        TO_CHAR(GPE_VINCULOM.DTADMISSAOVINC, 'DD/MM') AS DTADMISSAOVINC, 
        GPE_VINCULOM.NMVINCULOM, 
        TO_CHAR(GPE_PESSOAH.DTNASCPESSOA, 'DD/MM') AS DTNASCPESSOA, 
        GPE_PESSOA.NRPARCNEGOCIO, 
        --OPERADOR.DSEMAILOPER,
        CP.CDCOMUNICAPARC,
        MSG_ANIVERSARIO.DSTITULOMENSAGEM AS TITULO_NIVERNASC,
        MSG_ANIVERSARIO.DSMENSAGEM CORPO_NIVERNASC,
        MSG_TEMPOEMPRESA.DSTITULOMENSAGEM AS TITULO_NIVEREMPR,
        MSG_TEMPOEMPRESA.DSMENSAGEM CORPO_NIVEREMPR
        
    FROM GPE_PARAMORG
    
    JOIN ORGANIZACAO ON ORGANIZACAO.NRORG = GPE_PARAMORG.NRORG
    
    JOIN GPE_VINCULOM ON GPE_PARAMORG.NRORG = GPE_VINCULOM.NRORG
        AND GPE_VINCULOM.DTADMISSAOVINC < SYSDATE
        AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL OR GPE_VINCULOM.DTRESCISAOVINC > SYSDATE)
    
    JOIN GPE_PESSOA ON GPE_PESSOA.NRPESSOA = GPE_VINCULOM.NRPESSOA 
        AND GPE_PESSOA.NRORG = GPE_VINCULOM.NRORG
    
    JOIN GPE_PESSOAH ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA 
        AND GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
        AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT 
                                                MAX(PH2.DTMESCOMPETENC)
                                             FROM 
                                                GPE_PESSOAH PH2
                                             WHERE 
                                                PH2.NRORG              = GPE_PESSOAH.NRORG
                                                AND PH2.NRPESSOA       = GPE_PESSOAH.NRPESSOA
                                                AND PH2.DTMESCOMPETENC <= LAST_DAY(SYSDATE)
                                            )
   -- LEFT JOIN OPERADOR ON OPERADOR.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO 
   --     AND OPERADOR.NRORG = GPE_PESSOA.NRORG
    
    JOIN COMUNICAPARC CP ON CP.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO AND 
    CP.NRORG = GPE_PESSOA.NRORG AND CP.CDFORMACOMU = 05
    
    LEFT JOIN DES_MENSAGENSPADRAO MSG_ANIVERSARIO ON MSG_ANIVERSARIO.NRMENSAGENSPADRAO = GPE_PARAMORG.NRMENSANIVERSARIO
        AND MSG_ANIVERSARIO.NRORG = GPE_PARAMORG.NRORG

    LEFT JOIN DES_MENSAGENSPADRAO MSG_TEMPOEMPRESA ON MSG_TEMPOEMPRESA.NRMENSAGENSPADRAO = GPE_PARAMORG.NRMENSTEMPOEMPRESA
        AND MSG_TEMPOEMPRESA.NRORG = GPE_PARAMORG.NRORG
    
    WHERE ((GPE_PARAMORG.NRMENSANIVERSARIO IS NOT NULL AND TO_CHAR(GPE_PESSOAH.DTNASCPESSOA, 'DD/MM') = TO_CHAR(SYSDATE, 'DD/MM')) OR 
    (GPE_PARAMORG.NRMENSTEMPOEMPRESA IS NOT NULL AND TO_CHAR(GPE_VINCULOM.DTADMISSAOVINC, 'DD/MM') = TO_CHAR(SYSDATE, 'DD/MM')  ))
    ORDER BY GPE_PARAMORG.NRORG
SQL;
        $result = $db->fetchAll($sql,$params);

        if(isset($result[0])) return $result;
        else return null;
    }

}